=begin
= class Nusdas::NusPath

XbV (/) ؂̕pXeoB
͈ȉׂ̂ĂT|[gB

* /((|type|))/((|base|))/((|member|))/((|valid1|))/((|plane1|))/((|element|)) (`1) 
* /((|type|))/((|base|))/((|member|))/((|valid1|)),((|valid2|))/((|plane1|)),((|plane2|))/((|element|)) (`2)
* /((|type|))/((|base|))/((|member|))/((|valid1|))/((|valid2|))/((|plane1|))/((|plane2|))/((|element|)) (`)

E̎ȗ邱ƂłAȗ̂ nil ƂȂB

=end

module Nusdas
class NusPath

=begin
== O
--- FmtError
=end

    class FmtError < StandardError; end

=begin
== NX\bh
--- new string
    \zB
    `ƃ`̋ʂ͑4 (XbVŋ؂0琔n߂) 
    ((<NWPL::NwpTime|URL:../nwpl/nwptime.html>)) Ƃ݂Ȃꍇ
    `ƂAłȂꍇ̓`ƂB
=end

    def initialize (string)
        path = string.sub(/^\/*/, "").sub(/\/+$/, "").split(/\//)
	if path[4].nil? then
	    @old = false
	else
	    # ܂ƎvĂ݂
	    @valid2 = NWPL::NwpTime::new(path[4], true)
	    @old = !@valid2.oob?
	end
	@nustype = path[0]
	@basetime = (path[1] ? NWPL::NwpTime::new(path[1]) : nil)
	@member = path[2]
	if @old then
	    @valid1 = (path[3] ? NWPL::NwpTime::new(path[3]) : nil)
	    @plane1 = path[5]
	    @plane2 = path[6]
	    @element = path[7]
	    raise "path #{string} too deep" if path[8]
	else
	    if path[3] then
		v = path[3].split(/,/)
		@valid1 = NWPL::NwpTime::new(v.first)
		@valid2 = v[1] ? NWPL::NwpTime::new(v[1]) : nil
	    else
		@valid1 = @valid2 = nil
	    end
	    if path[4] then
	    	@plane1, @plane2 = path[4].split(/,/)
		@plane2 = @plane1 if @plane2.nil?
	    else
	    	@plane1 = @plane2 = nil
	    end
	    @element = path[5]
	    raise "path #{string} too deep" if path[6]
	end
	@member = "    " if @member == "none"
    end

=begin
== CX^X\bh
=== pX\vf
--- nustype
    sIh؂̕Ԃ
--- basetime
     ((<NWPL::NwpTime|URL:../nwpl/nwptime.html>)) ŕԂ
--- member
    O̕ԂB󔒃ȍꍇ "    " ԂB
--- member_str
    O̕ԂB󔒃ȍꍇ "none" ԂB
--- validtime
    Ώێ ((<NWPL::NwpTime|URL:../nwpl/nwptime.html>)) ŕԂ
    PƎ̏ꍇ NwpTime ̂́A
    Ԃ̏ꍇ NwpTime 2vf Array ƂȂB
--- validtime_str
    񉻂Ώێ
--- valid1
--- valid2
    PƑΏێ̏ꍇ valid2.undef? ^ɂȂB
    `ŕsSȃpX̂Ƃ nil ɂȂ
--- plane
    ʂ\ԂB
    ʊԂ̏ꍇ̓R}؂B
--- plane1
--- plane2
    PƖʂ̏ꍇ plane1 ƓɂȂB
    `ŕsSȃpX̂Ƃ nil ɂȂ
--- element
    vfԂ
--- old
    KĩpXō\zꂽꍇ^
=end

    attr_reader(:nustype, :basetime, :valid1, :valid2, :member)
    attr_reader(:plane1, :plane2, :element, :old)

    def member_str
	if (@member == "    ") then "none" else @member end
    end

    def validtime
	if (@valid2.nil? or @valid2.undef?) then
	    @valid1
	else
	    [@valid1, @valid2]
	end
    end

    def validtime= vt
	case vt
	when NWPL::NwpTime then
	    @valid1 = vt
	else
	    raise ArgumentError
	end
    end

    def validtime_str
	validtime.to_a.join(',')
    end

    def plane
	if @plane2.nil?
	    nil
	elsif @plane2 == @plane1 then
	    @plane1
	else
	    @plane1 + "," + @plane2
	end
    end

=begin
=== Xg擾
--- list (longp, schema = false)
    {Iɂ́Aŏ nil ɂȂĂ̂񋓂B
    Aŏ nil  basetime ɂȂĂ鎞ɌA
    nustype ^LN^܂łƂ nustype 񋓂B
    schema ^ɂȂĂꍇ͒`t@C̏񂾂
    񋓂쐬B
    longp ̌ʂ͂Ƃ肠̂ƂȂB
=end

    def glob_nustype type, longp
	search = Regexp::quote(type)
	search.gsub!(/\\\*/, '.*')
	search.gsub!(/\\\?/, '.')
	search = Regexp::new "^#{search}$"
	ret = []
	Nusdas::each_def do |deffile|
	    next unless search.match deffile.nustype
	    if longp then
		ret.push deffile.nustype + "\t" + deffile.to_s
	    else
		ret.push deffile.nustype
	    end
	end
	return ret
    end

    def list (longp, schema = false)
	return glob_nustype('*', longp) if nustype.nil?
	return glob_nustype(nustype, longp) \
	    if basetime.nil? and /[?*]/.match nustype
        if (schema) then
	    Nusdas::find_def(nustype).list_schema(self, longp)
	else
	    Nusdas::find_def(nustype).list_real(self, longp)
	end
    end

=begin
=== foOp
--- to_s
    `̕ԂB
=end

    def to_s
	[@nustype, @basetime, member_str, validtime_str, plane, @element].compact.join('/')
    end

end
end
# $Id: nuspath.rb,v 1.11 2002/08/01 10:38:27 suuchi43 Exp $
