set -e -x

: ${debug:=}

date +'%Y %m %d 12 00' > TIMECARD

for days in 01 02 03 04 05 06 07 08 09 10 11 12 49
do
	rm -rf NUSDAS${days}
	mkdir -p NUSDAS${days}/nusdas_def
	cat > NUSDAS${days}/nusdas_def/test.def <<EOF
path     relative_path PPJPC1/_basetime
filename _member
type1    _SF1 LL PP
type2    FC   SV
type3    JPC1
member 31 out
memberlist 00 01p 02p 03p 04p 05p 06p 07p 08p 09p 10p 11p 12p 13p 14p 15p
           01m 02 m 03m 04m 05m 06m 07m 08m 09m 10m 11m 12m 13m 14m 15m
validtime 961 HOUR in
validtime1 ARITHMETIC 00 06
plane 7
plane1 1000 850 700 500 300 200 100
element 5
elementmap U           0
elementmap V           0
elementmap T           0
elementmap Z           0
elementmap TTD         1  1 1 1 1 1 0 0
size 21 21
basepoint 1 1 110.0E 65.0N
distance 2.5 2.5
packing 2PAC
missing NONE
EOF
	if [ $days = 49 ]; then
		./test-write ${days} _SF1LLPP FCSV JPC1 00 1000 U 0 360 481
	elif [ $days = 01 ]; then
		./test-write ${days} _SF1LLPP FCSV JPC1 00 1000 U 0 360 41
	else
		ft0=`expr \( $days - 1 \) \* 10 \* 24 \* 60 + 360 || true`
		./test-write ${days} _SF1LLPP FCSV JPC1 00 1000 U ${ft0} 360 40
	fi
done
