#include "nusdas_sys.h"
#include <errno.h>

int  kw_num = 27;
char kw[][20]={ "nusdas","path","filename","creator","type1","type2",
		"basetime","member","memberlist","validtime",
		"validtime1","validtime2","plane","plane1","plane2","element",
		"elementmap","size","basepoint","distance","standard","others",
		"value","packing","missing","information","subcntl"};

int main(int argc, char *argv[])
{
FILE *fp;
int	i, j;
char ss[160];

	if (argc<2) {
		printf("nusdas_dump_def defile_file <keyword or all>\n");
		return;
	}
	if ((fp=fopen(argv[1], "r"))==NULL) {
		printf("define file <%s> can not be opened!\n", argv[1]);
		perror("");
		return;
	}

	if (argc==3) {

	if (strcmp(argv[2],"all")==0) {
		for(i=0; i<kw_num; i++) {
			j = n_def_read_key(fp, kw[i],ss);
			if (j==-1)
				printf("%s < no record >\n", kw[i]);
			else {
				printf("%s\n", ss);
			}
		}
	} else {
		j = n_def_read_key(fp, argv[2],ss);
		if (j==-1)
			printf("key word[%s] is not found!\n", argv[2]);
		else {
			printf("%s\n", ss);
		}
	}

	}
	fclose(fp);
        return 0;
}
