/**************************************
 *      MAKEBCHTu[`C      *
 *         Ver.1.0    1996.1.5        *
 *             A.Kinoshita            *
 **************************************/

int makebch(attr,kind,an,bch)		/* BCH */
char			*attr;
int				kind, an;
unsigned char	*bch;
{
	int	i;
	static unsigned char	data[45] = {3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
										2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	/*
		o[Wԍ,		data[ 0]				3,
		TCY,			data[ 1]				5,
		\,				data[ 2]				0,
		dԍ(x5),	data[ 3] - data[ 7]		0,0,0,0,0,
		p,			data[ 8]				0,
		nkÔgtO,		data[ 9]				0,
		\,				data[10]				0,
		eXgtO,		data[11]				0,
		\,				data[12]				0,
		f[^@x,		data[13]				0,
		f[^,			data[14]				0,
		\,				data[15]				0,
		f[^(x2),		data[16] - data[17]		0,0,
		^pԍ(x2),	data[18] - data[19]		0,0,
		đtO,			data[20]				0,
		f[^,			data[21]				0,
		f[^,			data[22]				0,
		A/N(x2),		data[23] - data[24]		0,0,
		QC(x4),			data[25] - data[28]		0,0,0,0,
		Mԍ,		data[29] - data[36]		2,0,0,0,0,0,0,0,
		Mԍ		data[37] - data[44]		0,0,0,0,0,0,0,0
	*/
	
	if(strlen(attr) != 3) return(-1);
	
	data[14] = 0;
	if((strcmp(attr,"A/N")) == 0 || (strcmp(attr,"jis")) == 0) data[14] = 1;
	if((strcmp(attr,"KAN")) == 0 || (strcmp(attr,"kan")) == 0) data[14] = 2;
	if((strcmp(attr,"BIN")) == 0 || (strcmp(attr,"bin")) == 0) data[14] = 5;
	if(data[14] == 0) return(-2);

	if(kind < 0 || kind >255)	return(-3);
	else						data[16] = kind/16;	data[17] = kind%16;
	if(an < 0 || an >255 || (data[14] != 5 && an != 0))		return(-4);
	else						data[23] = an/16;	data[24] = an%16;
	
	moveb(bch, 0,data, 0*8+4, 4);									/*	o[Wԍ	*/
	moveb(bch, 4,data, 1*8+4, 4);									/*	TCY		*/
	moveb(bch, 8,data, 2*8+4, 4);									/*	\			*/
	for(i = 0; i != 5; i++)	moveb(bch,12+4*i,data,( 3+i)*8+4, 4);	/*	dԍ	*/

	moveb(bch,32,data, 8*8+7, 1);									/*	p		*/
	moveb(bch,33,data, 9*8+7, 1);									/*	nkÔgtO	*/
	moveb(bch,34,data,10*8+7, 1);									/*	\			*/
	moveb(bch,35,data,11*8+7, 1);									/*	eXgtO	*/
	moveb(bch,36,data,12*8+6, 2);									/*	\			*/
	moveb(bch,38,data,13*8+6, 2);									/*	f[^@x	*/
	moveb(bch,40,data,14*8+4, 4);									/*	f[^		*/
	moveb(bch,44,data,15*8+4, 4);									/*	\			*/
	for(i = 0; i != 2; i++)	moveb(bch,48+4*i,data,(16+i)*8+4, 4);	/*	f[^		*/
	for(i = 0; i != 2; i++)	moveb(bch,56+4*i,data,(18+i)*8+4, 4);	/*	^pԍ	*/

	moveb(bch,64,data,20*8+7, 1);									/*	đtO		*/
	moveb(bch,65,data,21*8+5, 3);									/*	f[^		*/
	moveb(bch,68,data,22*8+4, 4);									/*	f[^		*/
	for(i = 0; i != 2; i++)	moveb(bch, 72+4*i,data,(23+i)*8+4, 4);	/*	A/N			*/
	for(i = 0; i != 4; i++)	moveb(bch, 80+4*i,data,(25+i)*8+4, 4);	/*	QC			*/
	for(i = 0; i != 8; i++)	moveb(bch, 96+4*i,data,(29+i)*8+4, 4);	/*	Mԍ	*/
	for(i = 0; i != 8; i++)	moveb(bch,128+4*i,data,(37+i)*8+4, 4);	/*	Mԍ	*/

	return(0);
}

/*********************************************************
 * CłmovebTu[`(moveb()bit_shift()1Zbg) *
 *********************************************************/
moveb(p,i,q,j,k)		/* rbgPʈړ֐ */
unsigned char	*p,*q;
int	i,j,k;
{
	int	byte,byte_len,out_byte,in_byte,out_shift,in_shift;

	byte_len	= (k+7)/8;
	out_byte	= i/8;	in_byte		= j/8;
	out_shift	= i%8;	in_shift	= j%8;

	for(byte = 0; byte != byte_len; byte++)
		bit_shift(p + out_byte + byte, out_shift, q + in_byte + byte, in_shift, k - 8*byte);
}

bit_shift(out_data,out_shift,in_data,in_shift, bit_len)	/* 1byte */
unsigned char	*in_data, *out_data;
int				out_shift, in_shift, bit_len;
{
	unsigned char	buf,tail, full = 0xFF;

	buf	 = *in_data     <<   in_shift;
	buf	|= *(in_data+1) >> 8-in_shift;

	if(bit_len < 8) {							/* f[^rbg				 */
		tail  = *out_data << out_shift;			/* loopifȂ̂ŁAspeeddȂ */
		tail |= *(out_data+1) >> 8-out_shift;	/* ʊ֐ɂ邱Ƃi߂			 */
		tail &= full ^ (full << 8-bit_len);
		 buf &= full << 8-bit_len;
		 buf |= tail;
	}

	*out_data		&= full << 8-out_shift;
	*out_data		|=  buf >>   out_shift;
	*(out_data+1)	&= full >>   out_shift;
	*(out_data+1)	|=  buf << 8-out_shift;
}

