! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
!   l\WCu 
!
!  PxŁ^{xł𓯂Tu[`̖Ŏg邽߂
!  Fortran90C^[tF[X
!
!  XV     | XV | XVe
!  -----------+--------+----------------------------------
!  2000.08.11 | Oikawa | VK쐬
!
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

module nwpl_mapproj_if

! xg̃}bvt@N^[
  interface NWP_MF_LM
    subroutine NWPS_MF_LM(mf,lat,im,jm,slate,slatp)
      real,dimension(*)::mf,lat
      integer im,jm
      real slate,slatp
    end subroutine NWPS_MF_LM 
    subroutine NWPD_MF_LM(mf,lat,im,jm,slate,slatp)
      double precision,dimension(*)::mf,lat
      integer im,jm
      double precision slate,slatp
    end subroutine NWPD_MF_LM 
  end interface

! |[XeĨ}bvt@N^[
  interface NWP_MF_PS
    subroutine NWPS_MF_PS(mf,lat,im,jm,slat)
      real,dimension(*)::mf,lat
      integer im,jm
      real slat
    end subroutine NWPS_MF_PS
    subroutine NWPD_MF_PS(mf,lat,im,jm,slat)
      double precision,dimension(*)::mf,lat
      integer im,jm
      double precision slat
    end subroutine NWPD_MF_PS
  end interface

! Jg̃}bvt@N^[
  interface NWP_MF_MR
    subroutine NWPS_MF_MR(mf,lat,im,jm,slat)
      real,dimension(*)::mf,lat
      integer im,jm
      real slat
    end subroutine NWPS_MF_MR
    subroutine NWPD_MF_MR(mf,lat,im,jm,slat)
      double precision,dimension(*)::mf,lat
      integer im,jm
      double precision slat
    end subroutine NWPD_MF_MR
  end interface

! xg
  interface NWP_MPROJ_LM2LL
    subroutine NWPS_MPROJ_LM2LL &
               (lat,lon,im,jm,dels,slate,slatp,slon,xi,xj,xlat,xlon)
      real,dimension(*)::lat,lon
      integer im,jm
      real dels,slate,slatp,slon,xi,xj,xlat,xlon
    end subroutine NWPS_MPROJ_LM2LL
    subroutine NWPD_MPROJ_LM2LL &
               (lat,lon,im,jm,dels,slate,slatp,slon,xi,xj,xlat,xlon)
      double precision,dimension(*)::lat,lon
      integer im,jm
      double precision dels,slate,slatp,slon,xi,xj,xlat,xlon
    end subroutine NWPD_MPROJ_LM2LL
  end interface

! |[XeI
  interface NWP_MPROJ_PS2LL
    subroutine NWPS_MPROJ_PS2LL(lat,lon,im,jm,dels,slat,slon,xi,xj,xlat,xlon)
      real,dimension(*)::lat,lon
      integer im,jm
      real dels,slat,slon,xi,xj,xlat,xlon
    end subroutine NWPS_MPROJ_PS2LL
    subroutine NWPD_MPROJ_PS2LL(lat,lon,im,jm,dels,slat,slon,xi,xj,xlat,xlon)
      double precision,dimension(*)::lat,lon
      integer im,jm
      double precision dels,slat,slon,xi,xj,xlat,xlon
    end subroutine NWPD_MPROJ_PS2LL
  end interface

! Jg
  interface NWP_MPROJ_MR2LL
    subroutine NWPS_MPROJ_MR2LL(lat,lon,im,jm,dels,slat,xi,xj,xlat,xlon)
      real,dimension(*)::lat,lon
      integer im,jm
      real dels,slat,xi,xj,xlat,xlon
    end subroutine NWPS_MPROJ_MR2LL
    subroutine NWPD_MPROJ_MR2LL(lat,lon,im,jm,dels,slat,xi,xj,xlat,xlon)
      double precision,dimension(*)::lat,lon
      integer im,jm
      double precision dels,slat,xi,xj,xlat,xlon
    end subroutine NWPD_MPROJ_MR2LL
  end interface

! ʁxg
  interface NWP_MPROJ_LL2LM
    subroutine NWPS_MPROJ_LL2LM(fi,fj,lat,lon,im,jm,dels,slate,slatp,slon, &
               xi,xj,xlat,xlon)
      real,dimension(*)::fi,fj,lat,lon
      integer im,jm
      real dels,slate,slatp,slon,xi,xj,xlat,xlon
    end subroutine NWPS_MPROJ_LL2LM
    subroutine NWPD_MPROJ_LL2LM(fi,fj,lat,lon,im,jm,dels,slate,slatp,slon, &
               xi,xj,xlat,xlon)
      double precision,dimension(*)::fi,fj,lat,lon
      integer im,jm
      double precision dels,slate,slatp,slon,xi,xj,xlat,xlon
    end subroutine NWPD_MPROJ_LL2LM
  end interface

! ʁ|[XeI
  interface NWP_MPROJ_LL2PS
    subroutine NWPS_MPROJ_LL2PS(fi,fj,lat,lon,im,jm,dels,slat,slon,xi,xj, &
               xlat,xlon)
      real,dimension(*)::fi,fj,lat,lon
      integer im,jm
      real dels,slat,slon,xi,xj,xlat,xlon
    end subroutine NWPS_MPROJ_LL2PS
    subroutine NWPD_MPROJ_LL2PS(fi,fj,lat,lon,im,jm,dels,slat,slon,xi,xj, &
               xlat,xlon)
      double precision,dimension(*)::fi,fj,lat,lon
      integer im,jm
      double precision dels,slat,slon,xi,xj,xlat,xlon
    end subroutine NWPD_MPROJ_LL2PS
  end interface

! ʁJg
  interface NWP_MPROJ_LL2MR
    subroutine NWPS_MPROJ_LL2MR(fi,fj,lat,lon,im,jm,dels,slat,xi,xj,xlat,xlon)
      real,dimension(*)::fi,fj,lat,lon
      integer im,jm
      real dels,slat,xi,xj,xlat,xlon
    end subroutine NWPS_MPROJ_LL2MR
    subroutine NWPD_MPROJ_LL2MR(fi,fj,lat,lon,im,jm,dels,slat,xi,xj,xlat,xlon)
      double precision,dimension(*)::fi,fj,lat,lon
      integer im,jm
      double precision dels,slat,xi,xj,xlat,xlon
    end subroutine NWPD_MPROJ_LL2MR
  end interface

! nȉ~̖ʁΎxg
  interface NWP_MPROJ_ELL2OLM
    subroutine NWPS_MPROJ_ELL2OLM(fi,fj,elat,elon,im,jm,dels,slate,slatp, &
               xi,xj,xlat,xlon,oslat,oslon,slat_el2sp)
      real,dimension(*)::fi,fj,elat,elon
      integer im,jm
      real dels,slate,slatp,xi,xj,xlat,xlon,oslat,oslon,slat_el2sp
    end subroutine NWPS_MPROJ_ELL2OLM
    subroutine NWPD_MPROJ_ELL2OLM(fi,fj,elat,elon,im,jm,dels,slate,slatp, &
               xi,xj,xlat,xlon,oslat,oslon,slat_el2sp)
      double precision,dimension(*)::fi,fj,elat,elon
      integer im,jm
      double precision dels,slate,slatp,xi,xj,xlat,xlon,oslat,oslon,slat_el2sp
    end subroutine NWPD_MPROJ_ELL2OLM
  end interface

! Ύxgnȉ~̖
  interface NWP_MPROJ_OLM2ELL
    subroutine NWPS_MPROJ_OLM2ELL(elat,elon,im,jm,dels,slate,slatp, &
               xi,xj,xlat,xlon,oslat,oslon,slat_el2sp)
      real,dimension(*)::elat,elon
      integer im,jm
      real dels,slate,slatp,xi,xj,xlat,xlon,oslat,oslon,slat_el2sp
    end subroutine NWPS_MPROJ_OLM2ELL
    subroutine NWPD_MPROJ_OLM2ELL(elat,elon,im,jm,dels,slate,slatp, &
               xi,xj,xlat,xlon,oslat,oslon,slat_el2sp)
      double precision,dimension(*)::elat,elon
      integer im,jm
      double precision dels,slate,slatp,xi,xj,xlat,xlon,oslat,oslon,slat_el2sp
    end subroutine NWPD_MPROJ_OLM2ELL
  end interface

! nȉ~̖ʁ
  interface NWP_MPROJ_EL2SP
    subroutine NWPS_MPROJ_EL2SP(lat,lon,elat,elon,im,jm,slat)
      real,dimension(*)::lat,lon,elat,elon
      integer im,jm
      real slat
    end subroutine NWPS_MPROJ_EL2SP
    subroutine NWPD_MPROJ_EL2SP(lat,lon,elat,elon,im,jm,slat)
      double precision,dimension(*)::lat,lon,elat,elon
      integer im,jm
      double precision slat
    end subroutine NWPD_MPROJ_EL2SP
  end interface

! ʁnȉ~̖
  interface NWP_MPROJ_SP2EL
    subroutine NWPS_MPROJ_SP2EL(elat,elon,lat,lon,im,jm,slat)
      real,dimension(*)::elat,elon,lat,lon
      integer im,jm
      real slat
    end subroutine NWPS_MPROJ_SP2EL
    subroutine NWPD_MPROJ_SP2EL(elat,elon,lat,lon,im,jm,slat)
      double precision,dimension(*)::elat,elon,lat,lon
      integer im,jm
      double precision slat
    end subroutine NWPD_MPROJ_SP2EL
  end interface

! ʁΎ
  interface NWP_MPROJ_SP2OB
    subroutine NWPS_MPROJ_SP2OB(olat,olon,lat,lon,im,jm,slat,slon)
      real,dimension(*)::olat,olon,lat,lon
      integer im,jm
      real slat,slon
    end subroutine NWPS_MPROJ_SP2OB
    subroutine NWPD_MPROJ_SP2OB(olat,olon,lat,lon,im,jm,slat,slon)
      double precision,dimension(*)::olat,olon,lat,lon
      integer im,jm
      double precision slat,slon
    end subroutine NWPD_MPROJ_SP2OB
  end interface

! Ύʁ
  interface NWP_MPROJ_OB2SP
    subroutine NWPS_MPROJ_OB2SP(lat,lon,olat,olon,im,jm,slat,slon)
      real,dimension(*)::lat,lon,olat,olon
      integer im,jm
      real slat,slon
    end subroutine NWPS_MPROJ_OB2SP
    subroutine NWPD_MPROJ_OB2SP(lat,lon,olat,olon,im,jm,slat,slon)
      double precision,dimension(*)::lat,lon,olat,olon
      integer im,jm
      double precision slat,slon
    end subroutine NWPD_MPROJ_OB2SP
  end interface

end module nwpl_mapproj_if
