/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

   l\WCu 

  ]ȉ~̖ʏ̈ܓxox  Ύxgʏ̎Wl
  Ύxgʏ̊iq_(Wl)  ]ȉ~̖ʏ̈ܓxox

  XV     | XV | XVe
  -----------+--------+------------------------------------
  1999.07.06 | Oikawa | VK쐬
  2000.08.04 | Oikawa | Ύxge̋tϊAΎϊA
             |        | ʁȉ~̕ϊȂǍ쐬
  2000.08.11 | Oikawa | {xEPxpFortran90C^[tF[X

  lF
    Eʂ]ȉ~̖ʂւ̕ΐAƂłȂ߁A]ȉ~
      ʂ狅ʂւ̕ϊō쐬e[ugĎĂB
    EΎxgʏ̊ox(fJgŴwx肷o)́Ae
      ̊_ʂ̂Ɖ肵ĂB
    EΎxgʏł́AΎʂɂ铌琼̌ɂȂB

 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "nwpl_mapproj.h"  /* vg^Cv錾 */

/* --------------------------------------------------------------------------
     ]ȉ~́Ύxg
   -------------------------------------------------------------------------- */
int nwp_mproj_ell2olm(double **fi,double **fj,double **elat,double **elon,    \
    int im,int jm,double dels,double slate,double slatp,                       \
    double xi,double xj,double xlat,double xlon,double oslat,double oslon,     \
    double slat_el2sp) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **fi       : Ύxgeʏ̂wW
   (O) double **fj       : Ύxgeʏ̂xW
   (I) double **elat     : ]ȉ~̖ʏ̈ܓx
   (I) double **elon     : ]ȉ~̖ʏ̌ox
   (I) int im            : ẘiq_
   (I) int jm            : x̊iq_
   (I) double dels       : iq_ԋ
   (I) double slate      : ~ʂƋʂ̌̈ܓx(ԓ)
   (I) double slatp      : ~ʂƋʂ̌̈ܓx(ɑ)
   (I) double xi         : eʏł̊_̂wW
   (I) double xj         : eʏł̊_̂xW
   (I) double xlat       : ȉ~̖ʏł̊_̈ܓx
   (I) double xlon       : ȉ~̖ʏł̊_̌ox
   (I) double oslat      : ΎƋʂ̌_̈ܓx
   (I) double oslon      : ΎƋʂ̌_̌ox
   (I) double slat_el2sp : Ɖ]ȉ~̂̐ړ_̈ܓx */

  int i,j,rc;
  double **lat,**lon,**olat,**olon,**tmp1,**tmp2,**tmp3,**tmp4;

  lat  = (double **)malloc(sizeof(double *)*jm);
  lon  = (double **)malloc(sizeof(double *)*jm);
  olat = (double **)malloc(sizeof(double *)*jm);
  olon = (double **)malloc(sizeof(double *)*jm);
  if(lat==NULL || lon==NULL || olat==NULL || olon==NULL) {
    printf("nwp_mproj_ell2olm: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<jm; j++) {
    lat[j]  = (double *)malloc(sizeof(double)*im);
    lon[j]  = (double *)malloc(sizeof(double)*im);
    olat[j] = (double *)malloc(sizeof(double)*im);
    olon[j] = (double *)malloc(sizeof(double)*im);
    if(lat[j]==NULL || lon[j]==NULL || olat[j]==NULL || olon[j]==NULL) {
      printf("nwp_mproj_ell2olm: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  } 
  
  tmp1 = (double **)malloc(sizeof(double *));
  tmp2 = (double **)malloc(sizeof(double *));
  tmp3 = (double **)malloc(sizeof(double *));
  tmp4 = (double **)malloc(sizeof(double *));
  *tmp1 = (double *)malloc(sizeof(double));
  *tmp2 = (double *)malloc(sizeof(double));
  *tmp3 = (double *)malloc(sizeof(double));
  *tmp4 = (double *)malloc(sizeof(double));

/* ]ȉ~̖ʂ狅ʂ֓e */
  if((rc=nwp_mproj_el2sp(lat,lon,elat,elon,im,jm,slat_el2sp))!=NWPL_NORMAL_END)
  {
    printf("nwp_mproj_ell2olm: Something wrong happened.\n");
    return NWPL_ABNORMAL_END;
  }

/* ]ȉ~̖ʂ狅ʂ֓e(e_) */
  **tmp3=xlat;
  **tmp4=xlon;
  if((rc=nwp_mproj_el2sp(tmp1,tmp2,tmp3,tmp4,1,1,slat_el2sp))!=NWPL_NORMAL_END)
  {
    printf("nwp_mproj_ell2olm: Something wrong happened.\n");
    return NWPL_ABNORMAL_END;
  }

/* ʂΎʂ֓e */
  if((rc=nwp_mproj_sp2ob(olat,olon,lat,lon,im,jm,oslat,oslon))!=NWPL_NORMAL_END)
  {
    printf("nwp_mproj_ell2olm: Something wrong happened.\n");
    return NWPL_ABNORMAL_END;
  }

/* ʂΎʂ֓e(e_) */
  if((rc=nwp_mproj_sp2ob(tmp3,tmp4,tmp1,tmp2,1,1,oslat,oslon))!=NWPL_NORMAL_END)
  {
    printf("nwp_mproj_ell2olm: Something wrong happened.\n");
    return NWPL_ABNORMAL_END;
  }

/* Ύʂ烉xgʂ֓e */
  if((rc=nwp_mproj_ll2lm(fi,fj,olat,olon,im,jm,dels,slate,slatp,**tmp4,xi,xj, \
         **tmp3,**tmp4))!=NWPL_NORMAL_END) {
    printf("nwp_mproj_ell2olm: Something wrong happened.\n");
    return NWPL_ABNORMAL_END;
  }
  
  for(j=0;j<jm;j++) {
    free(lat[j]); free(lon[j]); free(olat[j]); free(olon[j]);
  }
  free(lat); free(lon); free(olat); free(olon);
  free(tmp1); free(tmp2); free(tmp3); free(tmp4);

  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
     Ύxg]ȉ~
   -------------------------------------------------------------------------- */
int nwp_mproj_olm2ell(double **elat,double **elon,                            \
    int im,int jm,double dels,double slate,double slatp,                       \
    double xi,double xj,double xlat,double xlon,double oslat,double oslon,     \
    double slat_el2sp) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **elat     : ]ȉ~̖ʏ̈ܓx
   (O) double **elon     : ]ȉ~̖ʏ̌ox
   (I) int im            : ẘiq_
   (I) int jm            : x̊iq_
   (I) double dels       : iq_ԋ
   (I) double slate      : ~ʂƋʂ̌̈ܓx(ԓ)
   (I) double slatp      : ~ʂƋʂ̌̈ܓx(ɑ)
   (I) double xi         : eʏł̊_̂wW
   (I) double xj         : eʏł̊_̂xW
   (I) double xlat       : ȉ~̖ʏł̊_̈ܓx
   (I) double xlon       : ȉ~̖ʏł̊_̌ox
   (I) double oslat      : ΎƋʂ̌_̈ܓx
   (I) double oslon      : ΎƋʂ̌_̌ox
   (I) double slat_el2sp : Ɖ]ȉ~̂̐ړ_̈ܓx */

  int i,j,rc;
  double **lat,**lon,**olat,**olon,**tmp1,**tmp2,**tmp3,**tmp4;

  lat  = (double **)malloc(sizeof(double *)*jm);
  lon  = (double **)malloc(sizeof(double *)*jm);
  olat = (double **)malloc(sizeof(double *)*jm);
  olon = (double **)malloc(sizeof(double *)*jm);
  if(lat==NULL || lon==NULL || olat==NULL || olon==NULL) {
    printf("nwp_mproj_ell2olm: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<jm; j++) {
    lat[j]  = (double *)malloc(sizeof(double)*im);
    lon[j]  = (double *)malloc(sizeof(double)*im);
    olat[j] = (double *)malloc(sizeof(double)*im);
    olon[j] = (double *)malloc(sizeof(double)*im);
    if(lat[j]==NULL || lon[j]==NULL || olat[j]==NULL || olon[j]==NULL) {
      printf("nwp_mproj_ell2olm: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  tmp1 = (double **)malloc(sizeof(double *));
  tmp2 = (double **)malloc(sizeof(double *));
  tmp3 = (double **)malloc(sizeof(double *));
  tmp4 = (double **)malloc(sizeof(double *));
  *tmp1 = (double *)malloc(sizeof(double));
  *tmp2 = (double *)malloc(sizeof(double));
  *tmp3 = (double *)malloc(sizeof(double));
  *tmp4 = (double *)malloc(sizeof(double));

/* ]ȉ~̖ʂ狅ʂ֓e(e_) */
  **tmp3=xlat;
  **tmp4=xlon;
  if((rc=nwp_mproj_el2sp(tmp1,tmp2,tmp3,tmp4,1,1,slat_el2sp))!=NWPL_NORMAL_END)
  {
    printf("nwp_mproj_ell2olm: Something wrong happened.\n");
    return NWPL_ABNORMAL_END;
  }

/* ʂΎʂ֓e(e_) */
  if((rc=nwp_mproj_sp2ob(tmp3,tmp4,tmp1,tmp2,1,1,oslat,oslon))!=NWPL_NORMAL_END)
  {
    printf("nwp_mproj_ell2olm: Something wrong happened.\n");
    return NWPL_ABNORMAL_END;
  }

/* xgʂΎʂ֕ϊ */
  if((rc=nwp_mproj_lm2ll(olat,olon,im,jm,dels,slate,slatp,**tmp4,xi,xj,  \
         **tmp3,**tmp4))!=NWPL_NORMAL_END) {
    printf("nwp_mproj_ell2olm: Something wrong happened.\n");
    return NWPL_ABNORMAL_END;
  } 

/* Ύʂ琳ʂ֓e */
  if((rc=nwp_mproj_ob2sp(lat,lon,olat,olon,im,jm,oslat,oslon))!=NWPL_NORMAL_END)
  {
    printf("nwp_mproj_ell2olm: Something wrong happened.\n");
    return NWPL_ABNORMAL_END;
  }

/* ʂ]ȉ~̖ʂ֓e */
  if((rc=nwp_mproj_sp2el(elat,elon,lat,lon,im,jm,slat_el2sp))!=NWPL_NORMAL_END)
  {
    printf("nwp_mproj_ell2olm: Something wrong happened.\n");
    return NWPL_ABNORMAL_END;
  }

  for(j=0;j<jm;j++) {
    free(lat[j]); free(lon[j]); free(olat[j]); free(olon[j]);
  }
  free(lat); free(lon); free(olat); free(olon);
  free(tmp1); free(tmp2); free(tmp3); free(tmp4);

  return NWPL_NORMAL_END;
}
/* --------------------------------------------------------------------------
     ]ȉ~̖ʁʕϊ
   -------------------------------------------------------------------------- */
int nwp_mproj_el2sp(double **lat,double **lon,double **elat,double **elon,    \
    int im,int jm,double slat) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **lat  : ʏ̈ܓx
   (O) double **lon  : ʏ̌ox
   (I) double **elat : ȉ~̖ʏ̈ܓx
   (I) double **elon : ȉ~̖ʏ̌ox
   (I) double slat   : ȉ~̖ʂƋʂ̐ړ_̑ȉ~̖ʏ̈ܓx */

  int i,j;
  double rad,rrad,pi4,ecc2,slatr,c,elatr,t,h;
  
  rad = pi/180.0;
  rrad = 180.0/pi;
  pi4 = pi/4.0;
  ecc2 = pow(eccEarth,2.0);
  slatr = slat*rad;
  
  c = sqrt(1+ecc2*pow(cos(slatr),4.0)/(1-ecc2));
  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      if(fabs(elat[j][i])>90.0) {
        printf("nwp_mf_el2sp: illegal latitude value. (elat>90.0)\n");
        return NWPL_ERROR_NOTSENSIBLEVALUE;
      }
      elatr = elat[j][i]*rad;
      t = tan(pi4+elatr*0.5);
      h = pow((1-eccEarth*sin(elatr))/(1+eccEarth*sin(elatr)),eccEarth*0.5);
      lat[j][i] = (2.0*atan(pow(t*h,c))-pi/2.0)*rrad;
      lon[j][i] = c*elon[j][i];
    }
  }
  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
     ʁ]ȉ~̖ʕϊ
     []  ]ȉ~̖ʁʕϊ̃e[ugĂ̂ŎԂ
   -------------------------------------------------------------------------- */
int nwp_mproj_sp2el(double **elat, double **elon, double **lat, double **lon, \
    int im, int jm, double slat) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **elat : ȉ~̖ʏ̈ܓx
   (O) double **elon : ȉ~̖ʏ̌ox 
   (I) double **lat  : ʏ̈ܓx
   (I) double **lon  : ʏ̌ox
   (I) double slat   : ȉ~̖ʂƋʂ̐ړ_̑ȉ~̖ʏ̈ܓx */

  int i,j,k,kk;
  double rad,rrad,pi4,ecc2,slatr,c,rc,elatr,t,h,r1,r2;
  double *elatt,*latt;                                            /* e[u */
  int intval = 3600;                          /* ݕFPxɐ؂邩 */
  int kmax;
 
  kmax = 3600*180+1;
  elatt = (double *)malloc(sizeof(double)*kmax);
  latt  = (double *)malloc(sizeof(double)*kmax);

  rad = pi/180.0;
  rrad = 180.0/pi;
  pi4 = pi/4.0;
  ecc2 = pow(eccEarth,2.0);
  slatr = slat*rad;
 
/* ȉ~̖ʁʂ̈ܓxϊe[u */ 
  elatt[0] = 89.99999999;
  for(k=1; k<kmax; k++) {
    elatt[k] = elatt[k-1]-1.0/(double)intval;
  }

  c = sqrt(1+ecc2*pow(cos(slatr),4.0)/(1-ecc2));
  rc = 1.0/c;
  for(k=0; k<kmax; k++) {
    elatr = elatt[k]*rad;
    t = tan(pi4+elatr*0.5);
    h = pow((1-eccEarth*sin(elatr))/(1+eccEarth*sin(elatr)),eccEarth*0.5);
    latt[k] = (2.0*atan(pow(t*h,c))-pi/2.0)*rrad;
  }

  for(j=0;j<jm;j++) {
    for(i=0;i<im;i++) {
/* e[uōł߂lT */
      r1 = fabs(lat[j][i]-latt[0]);
      for(k=1; k<kmax; k++) {
        r2 = fabs(lat[j][i]-latt[k]);
        if(r2 >= r1) {
          kk = k-1;
          break;
        }
        r1 = r2;
      }
      elat[j][i] = elatt[kk];
      elon[j][i] = lon[j][i]*rc;
    }
  }

  free(elatt); free(latt);

  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
     Ύϊ
     []  Ύʂ̌ox́AƂ͋tBkɂ݂Ďv𐳂ƂB
   -------------------------------------------------------------------------- */
int nwp_mproj_sp2ob(double **olat,double **olon,double **lat,double **lon,    \
    int im,int jm,double slat,double slon) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **olat : Ύʏ̈ܓx
   (O) double **olon : Ύʏ̌ox
   (I) double **lat  : ʏ̈ܓx
   (I) double **lon  : ʏ̌ox
   (I) double slat   : ʏł̎Ύkɂ̈ܓx
   (I) double slon   : ʏł̎Ύkɂ̌ox */

  int i,j;
  double rad,rrad,slatr,slonr,olatr,olonr,latr,lonr;
  
  rad = pi/180.0;
  rrad = 180.0/pi;
  slatr = slat*rad;
  slonr = slon*rad;
  
  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      if(fabs(lat[j][i])>90.0) {
        printf("nwp_mproj_sp2ob: illegal latitude value. abs(lat)>90.0\n");
        return NWPL_ERROR_NOTSENSIBLEVALUE;
      }
      latr = lat[j][i]*rad;
      lonr = lon[j][i]*rad;
      olatr = asin(sin(slatr)*sin(latr)+cos(slatr)*cos(latr)*cos(lonr-slonr));
                                                              /* ʗ]藝 */
      olonr = atan(sin(lonr-slonr)*cos(latr)                                   \
                 /(sin(latr)*cos(slatr)-cos(latr)*sin(slatr)*cos(lonr-slonr)));
                                                              /* ʐ藝 */
      olat[j][i] = olatr*rrad;
      if(olonr < 0.0) { olon[j][i] = olonr*rrad+180.0;}
      else            { olon[j][i] = olonr*rrad;}
    }
  }
  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
     Ύϊ
   -------------------------------------------------------------------------- */
int nwp_mproj_ob2sp(double **lat, double **lon, double **olat, double **olon, \
    int im, int jm, double slat, double slon) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **lat  : ʏ̈ܓx
   (O) double **lon  : ʏ̌ox
   (I) double **olat : Ύʏ̈ܓx
   (I) double **olon : Ύʏ̌ox
   (I) double slat   : ʏł̎Ύkɂ̈ܓx
   (I) double slon   : ʏł̎Ύkɂ̌ox */

  int i,j;
  double rad,rrad,slatr,slonr,olatr,olonr,latr,lonr;
  
  rad = pi/180.0;
  rrad = 180.0/pi;
  slatr = slat*rad;
  slonr = slon*rad;
  
  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      if(fabs(olat[j][i])>90.0) {
        printf("nwp_mproj_ob2sp: illegal latitude value. abs(lat)>90.0\n");
        return NWPL_ERROR_NOTSENSIBLEVALUE;
      }
      olatr = olat[j][i]*rad;
      olonr = olon[j][i]*rad;
      latr = asin(sin(slatr)*sin(olatr)+cos(slatr)*cos(olatr)*cos(olonr));
      lonr = atan(sin(olonr)*cos(olatr)                                        \
           /(cos(slatr)*sin(olatr)-sin(slatr)*cos(olatr)*cos(olonr)));
      lat[j][i] = latr*rrad;
      lon[j][i] = lonr*rrad+slon;
    } 
  }
  return NWPL_NORMAL_END;
}

/* ==========================================================================
    Fortran 90 Ƃ̃C^[tF[Xp
    FortranvÓÃAhXnB
   ========================================================================== */

/* --- ]ȉ~̖ʁΎxg({xp) ------------------------------- */

int NWPD_MPROJ_ELL2OLM(double *fi,double *fj,double *elat,double *elon,        \
    int *im,int *jm,double *dels,double *slate,double *slatp,                  \
    double *xi,double *xj,double *xlat,double *xlon,double *oslat,             \
    double *oslon,double *slat_el2sp) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2,**tmp3,**tmp4;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  tmp3 = (double **)malloc(sizeof(double *)*(*jm));
  tmp4 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL || tmp3==NULL || tmp4==NULL) {
    printf("NWP_MPROJ_ELL2OLM: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    tmp3[j] = (double *)malloc(sizeof(double)*(*im));
    tmp4[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL || tmp3[j]==NULL || tmp4[j]==NULL) {
      printf("NWP_MPROJ_ELL2OLM: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp3[j][i] = elat[ij];
      tmp4[j][i] = elon[ij];
      ij++;
    }
  }

  nwp_mproj_ell2olm(tmp1,tmp2,tmp3,tmp4,*im,*jm,*dels,*slate,*slatp,*xi,*xj, \
    *xlat,*xlon,*oslat,*oslon,*slat_el2sp);

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      fi[ij] = tmp1[j][i];
      fj[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
    free(tmp3[j]);
    free(tmp4[j]);
  }
  free(tmp1);
  free(tmp2);
  free(tmp3);
  free(tmp4);
}

/* --- ]ȉ~̖ʁΎxg(Pxp) ------------------------------- */

int NWPS_MPROJ_ELL2OLM(float *fi,float *fj,float *elat,float *elon,        \
    int *im,int *jm,float *dels,float *slate,float *slatp,                  \
    float *xi,float *xj,float *xlat,float *xlon,float *oslat,             \
    float *oslon,float *slat_el2sp) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2,**tmp3,**tmp4;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  tmp3 = (double **)malloc(sizeof(double *)*(*jm));
  tmp4 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL || tmp3==NULL || tmp4==NULL) {
    printf("NWP_MPROJ_ELL2OLM: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    tmp3[j] = (double *)malloc(sizeof(double)*(*im));
    tmp4[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL || tmp3[j]==NULL || tmp4[j]==NULL) {
      printf("NWP_MPROJ_ELL2OLM: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp3[j][i] = elat[ij];
      tmp4[j][i] = elon[ij];
      ij++;
    }
  }

  nwp_mproj_ell2olm(tmp1,tmp2,tmp3,tmp4,*im,*jm,(double)(*dels), \
     (double)(*slate),(double)(*slatp),(double)(*xi),(double)(*xj), \
     (double)(*xlat),(double)(*xlon),(double)(*oslat),(double)(*oslon), \
     (double)(*slat_el2sp));

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      fi[ij] = tmp1[j][i];
      fj[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
    free(tmp3[j]);
    free(tmp4[j]);
  }
  free(tmp1);
  free(tmp2);
  free(tmp3);
  free(tmp4);
}

/* --- Ύxg]ȉ~̖({xp) ------------------------------- */

int NWPD_MPROJ_OLM2ELL(double *elat,double *elon,                              \
    int *im,int *jm,double *dels,double *slate,double *slatp,                  \
    double *xi,double *xj,double *xlat,double *xlon,double *oslat,             \
    double *oslon,double *slat_el2sp) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL) {
    printf("NWP_MPROJ_OLM2ELL: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL) {
      printf("NWP_MPROJ_OLM2ELL: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }

  nwp_mproj_olm2ell(tmp1,tmp2,*im,*jm,*dels,*slate,*slatp,*xi,*xj, \
    *xlat,*xlon,*oslat,*oslon,*slat_el2sp);

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      elat[ij] = tmp1[j][i];
      elon[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
  }
  free(tmp1);
  free(tmp2);
}

/* --- Ύxg]ȉ~̖(Pxp) ------------------------------- */

int NWPS_MPROJ_OLM2ELL(float *elat,float *elon,                              \
    int *im,int *jm,float *dels,float *slate,float *slatp,                  \
    float *xi,float *xj,float *xlat,float *xlon,float *oslat,             \
    float *oslon,float *slat_el2sp) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL) {
    printf("NWP_MPROJ_OLM2ELL: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL) {
      printf("NWP_MPROJ_OLM2ELL: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }

  nwp_mproj_olm2ell(tmp1,tmp2,*im,*jm,(double)(*dels),(double)(*slate), \
     (double)(*slatp),(double)(*xi),(double)(*xj),(double)(*xlat), \
     (double)(*xlon),(double)(*oslat),(double)(*oslon),(double)(*slat_el2sp));

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      elat[ij] = tmp1[j][i];
      elon[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
  }
  free(tmp1);
  free(tmp2);
}

/* --- ]ȉ~̖ʁ({xp) ----------------------------------------- */

int NWPD_MPROJ_EL2SP(double *lat,double *lon,double *elat,double *elon,        \
    int *im,int *jm,double *slat) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2,**tmp3,**tmp4;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  tmp3 = (double **)malloc(sizeof(double *)*(*jm));
  tmp4 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL || tmp3==NULL || tmp4==NULL) {
    printf("NWP_MPROJ_EL2SP: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    tmp3[j] = (double *)malloc(sizeof(double)*(*im));
    tmp4[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL || tmp3[j]==NULL || tmp4[j]==NULL) {
      printf("NWP_MPROJ_EL2SP: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp3[j][i] = elat[ij];
      tmp4[j][i] = elon[ij];
      ij++;
    }
  }

  nwp_mproj_el2sp(tmp1,tmp2,tmp3,tmp4,*im,*jm,*slat);

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      lat[ij] = tmp1[j][i];
      lon[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
    free(tmp3[j]);
    free(tmp4[j]);
  }
  free(tmp1);
  free(tmp2);
  free(tmp3);
  free(tmp4);
}

/* --- ]ȉ~̖ʁ(Pxp) ----------------------------------------- */

int NWPS_MPROJ_EL2SP(float *lat,float *lon,float *elat,float *elon,        \
    int *im,int *jm,float *slat) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2,**tmp3,**tmp4;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  tmp3 = (double **)malloc(sizeof(double *)*(*jm));
  tmp4 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL || tmp3==NULL || tmp4==NULL) {
    printf("NWP_MPROJ_EL2SP: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    tmp3[j] = (double *)malloc(sizeof(double)*(*im));
    tmp4[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL || tmp3[j]==NULL || tmp4[j]==NULL) {
      printf("NWP_MPROJ_EL2SP: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp3[j][i] = elat[ij];
      tmp4[j][i] = elon[ij];
      ij++;
    }
  }

  nwp_mproj_el2sp(tmp1,tmp2,tmp3,tmp4,*im,*jm,(double)(*slat));

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      lat[ij] = tmp1[j][i];
      lon[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
    free(tmp3[j]);
    free(tmp4[j]);
  }
  free(tmp1);
  free(tmp2);
  free(tmp3);
  free(tmp4);
}

/* --- ʁ]ȉ~̖({xp) ----------------------------------------- */

int NWPD_MPROJ_SP2EL(double *elat,double *elon,double *lat,double *lon,        \
    int *im,int *jm,double *slat) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2,**tmp3,**tmp4;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  tmp3 = (double **)malloc(sizeof(double *)*(*jm));
  tmp4 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL || tmp3==NULL || tmp4==NULL) {
    printf("NWP_MPROJ_SP2EL: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    tmp3[j] = (double *)malloc(sizeof(double)*(*im));
    tmp4[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL || tmp3[j]==NULL || tmp4[j]==NULL) {
      printf("NWP_MPROJ_SP2EL: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp3[j][i] = lat[ij];
      tmp4[j][i] = lon[ij];
      ij++;
    }
  }

  nwp_mproj_sp2el(tmp1,tmp2,tmp3,tmp4,*im,*jm,*slat);

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      elat[ij] = tmp1[j][i];
      elon[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
    free(tmp3[j]);
    free(tmp4[j]);
  }
  free(tmp1);
  free(tmp2);
  free(tmp3);
  free(tmp4);
}

/* --- ʁ]ȉ~̖(Pxp) ----------------------------------------- */

int NWPS_MPROJ_SP2EL(float *elat,float *elon,float *lat,float *lon,        \
    int *im,int *jm,float *slat) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2,**tmp3,**tmp4;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  tmp3 = (double **)malloc(sizeof(double *)*(*jm));
  tmp4 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL || tmp3==NULL || tmp4==NULL) {
    printf("NWP_MPROJ_SP2EL: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    tmp3[j] = (double *)malloc(sizeof(double)*(*im));
    tmp4[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL || tmp3[j]==NULL || tmp4[j]==NULL) {
      printf("NWP_MPROJ_SP2EL: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp3[j][i] = lat[ij];
      tmp4[j][i] = lon[ij];
      ij++;
    }
  }

  nwp_mproj_sp2el(tmp1,tmp2,tmp3,tmp4,*im,*jm,(double)(*slat));

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      elat[ij] = tmp1[j][i];
      elon[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
    free(tmp3[j]);
    free(tmp4[j]);
  }
  free(tmp1);
  free(tmp2);
  free(tmp3);
  free(tmp4);
}

/* --- Ύϊ({xp) ----------------------------------------------- */

int NWPD_MPROJ_SP2OB(double *olat,double *olon,double *lat,double *lon,        \
    int *im,int *jm,double *slat,double *slon) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2,**tmp3,**tmp4;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  tmp3 = (double **)malloc(sizeof(double *)*(*jm));
  tmp4 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL || tmp3==NULL || tmp4==NULL) {
    printf("NWP_MPROJ_SP2OB: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    tmp3[j] = (double *)malloc(sizeof(double)*(*im));
    tmp4[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL || tmp3[j]==NULL || tmp4[j]==NULL) {
      printf("NWP_MPROJ_SP2OB: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp3[j][i] = lat[ij];
      tmp4[j][i] = lon[ij];
      ij++;
    }
  }

  nwp_mproj_sp2ob(tmp1,tmp2,tmp3,tmp4,*im,*jm,*slat,*slon);

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      olat[ij] = tmp1[j][i];
      olon[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
    free(tmp3[j]);
    free(tmp4[j]);
  }
  free(tmp1);
  free(tmp2);
  free(tmp3);
  free(tmp4);
}

/* --- Ύϊ(Pxp) ----------------------------------------------- */

int NWPS_MPROJ_SP2OB(float *olat,float *olon,float *lat,float *lon,        \
    int *im,int *jm,float *slat,float *slon) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2,**tmp3,**tmp4;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  tmp3 = (double **)malloc(sizeof(double *)*(*jm));
  tmp4 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL || tmp3==NULL || tmp4==NULL) {
    printf("NWP_MPROJ_SP2OB: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    tmp3[j] = (double *)malloc(sizeof(double)*(*im));
    tmp4[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL || tmp3[j]==NULL || tmp4[j]==NULL) {
      printf("NWP_MPROJ_SP2OB: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp3[j][i] = lat[ij];
      tmp4[j][i] = lon[ij];
      ij++;
    }
  }

  nwp_mproj_sp2ob(tmp1,tmp2,tmp3,tmp4,*im,*jm,(double)(*slat),(double)(*slon));

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      olat[ij] = tmp1[j][i];
      olon[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
    free(tmp3[j]);
    free(tmp4[j]);
  }
  free(tmp1);
  free(tmp2);
  free(tmp3);
  free(tmp4);
}

/* --- Ύϊ({xp) ----------------------------------------------- */

int NWPD_MPROJ_OB2SP(double *lat,double *lon,double *olat,double *olon,        \
    int *im,int *jm,double *slat,double *slon) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2,**tmp3,**tmp4;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  tmp3 = (double **)malloc(sizeof(double *)*(*jm));
  tmp4 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL || tmp3==NULL || tmp4==NULL) {
    printf("NWP_MPROJ_OB2SP: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    tmp3[j] = (double *)malloc(sizeof(double)*(*im));
    tmp4[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL || tmp3[j]==NULL || tmp4[j]==NULL) {
      printf("NWP_MPROJ_OB2SP: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp3[j][i] = olat[ij];
      tmp4[j][i] = olon[ij];
      ij++;
    }
  }

  nwp_mproj_ob2sp(tmp1,tmp2,tmp3,tmp4,*im,*jm,*slat,*slon);

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      lat[ij] = tmp1[j][i];
      lon[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
    free(tmp3[j]);
    free(tmp4[j]);
  }
  free(tmp1);
  free(tmp2);
  free(tmp3);
  free(tmp4);
}
  
/* --- Ύϊ(Pxp) ----------------------------------------------- */

int NWPS_MPROJ_OB2SP(float *lat,float *lon,float *olat,float *olon,        \
    int *im,int *jm,float *slat,float *slon) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2,**tmp3,**tmp4;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  tmp3 = (double **)malloc(sizeof(double *)*(*jm));
  tmp4 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL || tmp3==NULL || tmp4==NULL) {
    printf("NWP_MPROJ_OB2SP: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    tmp3[j] = (double *)malloc(sizeof(double)*(*im));
    tmp4[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL || tmp3[j]==NULL || tmp4[j]==NULL) {
      printf("NWP_MPROJ_OB2SP: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp3[j][i] = olat[ij];
      tmp4[j][i] = olon[ij];
      ij++;
    }
  }

  nwp_mproj_ob2sp(tmp1,tmp2,tmp3,tmp4,*im,*jm,(double)(*slat),(double)(*slon));

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      lat[ij] = tmp1[j][i];
      lon[ij] = tmp2[j][i];
      ij++;
    }
  }
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
    free(tmp3[j]);
    free(tmp4[j]);
  }
  free(tmp1);
  free(tmp2);
  free(tmp3);
  free(tmp4);
}

