#include <stdio.h>
#include "nusdas.h"

struct errtab_t {
	int	code;
	char	*msg;
};

static struct errtab_t msgtab_default[] = {
#include "errtab.h"
	0, NULL
};

	const char *
nusdas_strerror(int errcode)
{
	struct errtab_t *p;

	for (p = msgtab_default; p->msg; p++) {
		if (p->code == errcode)
			return p->msg;
	}

	return "unknown error";
}
