#line 1 "wrapf90.ca"

# include "nusdas_sys.h"
# include "config_fortran.h"
# define CHAR char
# define INTEGER int
# define REAL float
# define DOUBLE double

#line 424 "wrapf90.ca"

void

#ifdef C_FORTRAN_UPPER
NUSDAS_GRID2
#else
#  ifdef C_FORTRAN_LOWER_
nusdas_grid2_
#  else
fnusdas_grid2
#  endif
#endif

#line 428 "wrapf90.ca"
(const CHAR *utype1,
 const CHAR *utype2,
 const CHAR *utype3,
 INTEGER *basetime,
 const CHAR *udescriptor,
 INTEGER *validtime1,
 INTEGER *validtime2,
 CHAR *projection,
 INTEGER *g_size,
 REAL *g_info,
 CHAR *g_mean,
 const CHAR *action,
 INTEGER *rt)
{
    *rt = nusdas_grid2(utype1, utype2, utype3, basetime, udescriptor,
		       validtime1,
		       validtime2, projection, g_size, g_info, g_mean,
		       action);
}

