#line 1 "wrapf90.ca"

# include "nusdas_sys.h"
# include "config_fortran.h"
# define CHAR char
# define INTEGER int
# define REAL float
# define DOUBLE double

#line 490 "wrapf90.ca"

void

#ifdef C_FORTRAN_UPPER
NUSDAS_INQ_CNTL2
#else
#  ifdef C_FORTRAN_LOWER_
nusdas_inq_cntl2_
#  else
fnusdas_inq_cntl2
#  endif
#endif

#line 494 "wrapf90.ca"
(const CHAR *utype1, const CHAR *utype2,
		 const CHAR *utype3, INTEGER *basetime,
		 const CHAR *udescriptor, INTEGER *validtime1,
		 INTEGER *validtime2, INTEGER *param, void *data,
		 INTEGER *dnum, INTEGER *rt)
{
    *rt = nusdas_inq_cntl2(utype1, utype2, utype3, basetime, udescriptor,
			   validtime1, validtime2, *param, data, dnum);
}

