# require "nusdas/nusrecord"

=begin
= class Nusdas::NusRecStream

((<ruby gݍ݂ File|URL:http://www.ruby-lang.org/ja/man-1.6/?cmd=view;name=File>)) pĂB

܂̂ƂAǂݎ肾B
=end

module Nusdas
class NusRecStream < File

=begin
== ŔO
:FmtError
  IOError p
=end

    class FmtError < IOError
    end

=begin
== NX\bh
--- self::new (file, mode = "r", perm = 0666)
    PɃt@CJłȂA binmode ɂB
=end

    def initialize (file, mode = "r", perm = 0666)
        super
        binmode
	@tell_backspace = nil
    end

    attr_reader :tell_backspace

=begin
--- self::open (file, mode = "r", perm = 0666)
    PɃt@CJłȂA binmode ɂB
=end

    def self::open(filename, mode = "r", perm = 0666)
        r = super
        r.binmode
    end

=begin
== CX^X\bh
--- get_record_str
    1R[hǂށBԋpl̓wb_ƃyC[hȂ2vfzB
    t@CGhɗĂ nil ԂB
    * R[h̍\͈ȉ̒ʂB
      T^I FORTRAN ȂҐt@CƂ肾ႤB
      L^͋L^g܂ނ FORTRAN ͓ǂ߂ȂB
      * wb_
        * L^: 32rbg (PʃoCg)
        * L^: 4oCg
        * L^L: 32rbg
        * XV: 32rbgAunix time ̕ԋpl
      * yC[h
        (yC[h̒ (L^ - 20) oCgł邪A
        ̂LȂ̂ (L^L - 12) )
      * L^
--- get_record
    1R[hǂ ((<NusRecord|URL:nusrecord.html>)) \zĕԂB
    t@CGhɗĂ nil ԂB
    G[ ((<FmtError>)) ԂB
    * ((**)) ŕ NUSDAS_WRITE ꂽꍇA
       DATA R[h݂邱ƂɂȂB
      ̏ꍇAINDX R[hɎwĂ̂LłB
      L DATA R[hQƂꍇ
      ((<Nusdas::NusFile|URL:nusfile.html>)) gƁB
=end

    def get_record_str()
        # wb_
	@tell_backspace = self.tell
        head = read(16)
	return nil if head.nil?
	raise FmtError, "too short record" if head.length < 16

        # yC[h
        recl = head.unpack("N").first
	vrecl = head.unpack("x8N").first - 12
        payload = self.read(recl - 20)[0, vrecl]
	if payload.nil? or payload.length < (recl - 20) then
	    raise FmtError, "too short record: missing payload"
	end

        # L^̊mF (wb_̋L^ƂĂ邩)
        tail = read(4)
        if tail.nil? or tail.length < 4 then
            raise(FmtError, "malformed record: missing tail")
        end
        tailed = tail.unpack('N').first
        if (tailed != recl) then
            raise(FmtError, "record length mismatch #{tailed} #{r.size}")
        end
        return [head, payload]
    end

    def get_record()
        require "nusdas/nusrecord"
        head, payload = get_record_str()
	return nil if head.nil?
	return NusRecord.new(head, payload)
    end

=begin
== foOp\bh
--- self::debug
    R}hC̃t@Cɂ get_record Ă݂B
=end

    def self::debug
        for filename in ARGV
            input = NusRecStream::open(filename)
            while 1
                itell = input.tell
                r = input.get_record
                break if (r == nil)
                print "#{sprintf '%04x', itell} #{r.inspect}\n"
            end
            input.close
        end
    end

end
end
# $Id: nusrecstream.rb,v 1.14 2003/02/10 07:57:08 suuchi43 Exp $
