require 'nwplraw.so'

print <<EOF
--- test 3: week continuity test
EOF

# test for Aug 2002

1.upto(31) do |day|
	bstr = format("2002-08-%02dt0000", day)
	base = NWPL::NwpTime::new(bstr)
	ref = Time::gm(2002, 8, day).wday
	raise "#{base.wday} #{ref}" if base.wday != ref
end

base = cur = NWPL::NwpTime::new("2002-08-04")
p base.wday

6750.times do |i|
	cur += 1440 * 7 * 30
	raise [i, cur, cur.wday].join(' ') if cur.wday != 0
end

cur = base

7451.times do |i|
	cur -= 1440 * 7 * 30
	raise [i, cur, cur.wday].join(' ') if cur.wday != 0
end

