#include <stdio.h>

int main(int argc, char *argv[])
{
unsigned char *d;
FILE *fpi, *fpo;
int offset, rlens, alen, xs=-1, ys=-1;
char rname[5];
rname[4]='\0';

  if ((fpi=fopen(argv[1], "r"))==NULL) {
    printf("input file open error! file=%s\n", argv[1]);
    exit(1);
  } else {
    printf("%s >>> ", argv[1]);
  }
  if ((fpo=fopen(argv[2], "w"))==NULL) {
    printf("output file open error! file=%s\n", argv[2]);
    exit(1);
  } else {
    printf(">>> %s\t", argv[2]);
  }
  while(1) {
    if (fread(&rlens, 4, 1, fpi)!=1) break;
    fread(rname, 4, 1, fpi);
    if (strcmp(rname,"DATA")==0 || strcmp(rname,"data")==0) {
      if (xs<=0 || ys<=0) {
        printf("size error! <xs:%-d, ys:%-d>\n", xs, ys);
        exit(1);
      }
      fread(&alen, 4, 1, fpi);
      rlens += 8; alen += 8;
      if ((d=(unsigned char *)malloc(sizeof(unsigned char)*rlens))==NULL) {
        printf("malloc error! size=%d\n", rlens);
        exit(1);
      }
      memcpy(d, &rlens, 4); memcpy((unsigned char *)(d+4), rname, 4);
      memcpy((unsigned char *)(d+8), &alen, 4);
      fread((unsigned char *)(d+12), 36, 1, fpi);
      memcpy((unsigned char *)(d+48), &xs, 4);
      memcpy((unsigned char *)(d+52), &ys, 4);
      if (fread((unsigned char *)(d+56), rlens-8-48, 1, fpi)!=1) {
        printf("fread error!\n");
        exit(1);
      }
      memcpy((unsigned char *)(d+rlens-4), &rlens, 4);
      if (fwrite(d, rlens, 1, fpo)!=1) {
        printf("fwrite error!\n");
        exit(1);
      }
    } else {
      if ((d=(unsigned char *)malloc(sizeof(unsigned char)*rlens))==NULL) {
        printf("malloc error! size=%d\n", rlens);
        exit(1);
      }
      memcpy(d, &rlens, 4); memcpy((unsigned char *)(d+4), rname, 4);
      if (fread((unsigned char *)(d+8), rlens-8, 1, fpi)!=1) {
        printf("fread error!\n");
        exit(1);
      }
      if (fwrite(d, rlens, 1, fpo)!=1) {
        printf("fwrite error!\n");
        exit(1);
      }
      if (strcmp(rname,"CNTL")==0 || strcmp(rname,"cntl")==0) {
        memcpy(&xs, (unsigned char *)(d+72), 4);
        memcpy(&ys, (unsigned char *)(d+76), 4);
      }
    }
  }
  fclose(fpi);
  fclose(fpo);
  printf("  succeeded!!\n");
}
