#include <stdio.h>
#include <time.h>
char ox[]="OX";
int main(int argc, char *argv[])
{
unsigned char *ud[2];
FILE  *fp[2], *fpo;
int  rlens[2], rlene[2], alen[2], stime[2], offset[2];
unsigned int rname[2];
int  y, m, d, h, f, size[2], vt[2];
int  i, vf=0, ef=0, df, cf=0, sf=0, nf=0, cc=0, ss=0, nn=0;
char srname[5], memb[2][5], levl[2][7], elem[2][7];
struct tm *tp;
memb[0][4]='\0'; levl[0][6]='\0'; elem[0][6]='\0';
memb[1][4]='\0'; levl[1][6]='\0'; elem[1][6]='\0';

  if (argc<3) {
    fprintf(stderr, "------------------------------------------------------\n");
    fprintf(stderr, "usage: nuscmp file1 file2 (-v,-V) (-c) (-s) (-n)\n");
    fprintf(stderr, "------------------------------------------------------\n");
    fprintf(stderr, "nuscmp compare file1 and file2.\n");
    fprintf(stderr, "same file case -> return 0, and different file case -> return 1\n");
    fprintf(stderr, "If -v or -V is specified, difference of create time is ignored.\n");
    fprintf(stderr, "In case of -V, the comparison is continued to the end of file\n"); 
    fprintf(stderr, "except for the fatal difference and record detail information are printted out.\n");
    fprintf(stderr, "If -n is specified, difference of NuSDaS NUSD record is ignored.\n");
    fprintf(stderr, "If -c is specified, difference of NuSDaS CNTL record is ignored.\n");
    fprintf(stderr, "If -s is specified, difference of NuSDaS SUBC record is ignored.\n");
    return(9);
  }
  if ((fp[0]=fopen(argv[1], "r"))==NULL) {
    fprintf(stderr, "nuscmp: can not open file <%s>\n", argv[1]); return(9);
  }
  if ((fp[1]=fopen(argv[2], "r"))==NULL) {
    fprintf(stderr, "nuscmp: can not open file <%s>\n", argv[2]); return(9);
  }
  if (argc>3)
    vf = (strcmp(argv[3],"-v")==0) ? 1 : (strcmp(argv[3],"-V")==0) ? 2 : 0; 
  for(i=3; i<argc; i++)
    if      (strcmp(argv[i], "-v")==0)  vf = 1;
    else if (strcmp(argv[i], "-V")==0)  vf = 2;
    else if (strcmp(argv[i], "-c")==0)  cf = 1;
    else if (strcmp(argv[i], "-s")==0)  sf = 1;
    else if (strcmp(argv[i], "-n")==0)  nf = 1;

  if (vf==2) {
    printf("***************************************************************\n");
    printf("nuscmp: file1=%s\n", argv[1]);
    printf("        file2=%s\n", argv[2]);
    printf("***************************************************************\n");
    printf("?       length createT1/createT2 valid-T1/valid-T2 level1/level2 elem-1/elem-2\n");
  }
  while(1) {

    if (fread_native(&rlens[0], 4, 1, fp[0])!=1) break;
    if (fread_native(&rlens[1], 4, 1, fp[1])!=1) break;
    fread_native(&rname[0], 1, 4, fp[0]);
    fread_native(&rname[1], 1, 4, fp[1]);
    fread_native(&alen[0], 4, 1, fp[0]);
    fread_native(&alen[1], 4, 1, fp[1]);
    fread_native(&stime[0], 4, 1, fp[0]);
    fread_native(&stime[1], 4, 1, fp[1]);
    size[0] = rlens[0]-20;               size[1] = rlens[1]-20;
    ud[0] = (unsigned char *)malloc(sizeof(unsigned char)*size[0]);
    ud[1] = (unsigned char *)malloc(sizeof(unsigned char)*size[1]);
    fread_native(ud[0], 1, size[0], fp[0]);     
    fread_native(ud[1], 1, size[1], fp[1]);
    fread_native(&rlene[0], 4, 1, fp[0]);       
    fread_native(&rlene[1], 4, 1, fp[1]);

    if (rlens[0]!=rlens[1]) {fprintf(stderr, "different files!\n"); return(1);}
    if (rname[0]!=rname[1]) {fprintf(stderr, "different files!\n"); return(1);}
    if (alen[0]!=alen[1])   {fprintf(stderr, "different files!\n"); return(1);}
    if (stime[0]!=stime[1]) {
      if (ef==0) ef=1;
      if (vf==0)            {fprintf(stderr, "different files!\n"); return(1);}
    }
    for(i=0; i<2; i++)
      if (rlens[i]!=rlene[i]) {
        fprintf(stderr,"nuscmp: inconsistent record length <s:%d,e:%d> on file%1.1d\n", rlens[i], rlene[i], i);
        return(2);
      }
    df = memcmp(ud[0], ud[1], size[0]);
    if (df!=0) {
      df=1;
      if      (memcmp(&rname[0],"CNTL",4)==0 && cf==1) cc=1;
      else if (memcmp(&rname[0],"SUBC",4)==0 && sf==1) ss=1;
      else if (memcmp(&rname[0],"NUSD",4)==0 && nf==1) nn=1;
      else                                             ef=2;
    }
    if (vf<=1 && ef==2) {
      fprintf(stderr, "different files!\n"); return(1);
    } else if (vf==2) {
      memcpy(srname, &rname[0], 4); srname[4]='\0';
      tp = gmtime((time_t*)&stime[0]);
      printf("%c<%4s> %6d %2.2d%2.2d%2.2d%2.2d",ox[df], srname, rlens[0],
             tp->tm_mon+1,tp->tm_mday,tp->tm_hour,tp->tm_min);
      tp = gmtime((time_t*)&stime[1]);
      printf("/%2.2d%2.2d%2.2d%2.2d",
            tp->tm_mon+1,tp->tm_mday,tp->tm_hour,tp->tm_min);
      if (strcmp(srname,"DATA")==0) {
        for(i=0; i<2; i++) {
          memcpy(memb[i], (ud[i]+0), 4); memcpy(&vt[i], (ud[i]+4), 4);
          memcpy(levl[i], (ud[i]+12), 6); memcpy(elem[i], (ud[i]+24), 6);
        }
        nwp_seq2ymdhm(&y,&m,&d,&h,&f,vt[0]);
        printf(" %2.2d%2.2d%2.2d%2.2d", m,d,h,f);
        nwp_seq2ymdhm(&y,&m,&d,&h,&f,vt[1]);
        printf("/%2.2d%2.2d%2.2d%2.2d", m,d,h,f);
        printf(" %6s/%6s %6s/%6s\n", levl[0],levl[1], elem[0],elem[1]);
      } else 
        printf("\n");
    }
    free(ud[0]);
    free(ud[1]);
  }

  fclose(fp[0]);
  fclose(fp[1]);
  if (ef==0) {
    fprintf(stderr, "Same files!\n");
    return(0);
  } else if (ef==1) {
    fprintf(stderr, "Same files except for create time!\n");
    if (nn==1) fprintf(stderr, "Same files except for NUSD record!\n");
    if (cc==1) fprintf(stderr, "Same files except for CNTL record!\n");
    if (ss==1) fprintf(stderr, "Same files except for SUBC record!\n");
    return(0);
  } else {
    fprintf(stderr, "Above X record(s) is(are) different!\n");
    return(1);
  }
}
