#include "n2g.h"
extern int pflag;

void clear_tl(ST_TARGET *tl, char *outfile)
{
  strcpy(tl->type1, "        ");
  strcpy(tl->type2, "    ");
  strcpy(tl->type3, "    ");
  strcpy(tl->memb, "    ");
  strcpy(tl->levl, "      ");
  strcpy(tl->levl2, "      ");
  strcpy(tl->elem, "      ");
  strcpy(tl->fname, outfile);
  tl->bec = ' ';
  tl->vt = -1;
  tl->vt2= -1;
  tl->be = 255;
  tl->xs = -999; tl->xe = -999; tl->xd = -999;
  tl->ys = -999; tl->ye = -999; tl->yd = -999;
}

int rdtarget(FILE *fp, ST_TARGET *tl, ST_TARGET *tld, char *outfile)
{
char sl[240], ss[80];
int i, j, k, rt;
ST_TARGET *tlw;

nextline:
  if (fgets(sl, 240, fp)==NULL)  return(-1);
  if (sl[0]=='#')  goto nextline;
/*
  if (sl[strlen(sl)-1]=='\n') sl[strlen(sl)-1] = '\0';
  for(k=strlen(sl); k<80; k++)  sl[k] = ' '; sl[k] = '\0';
*/
  if (sl[strlen(sl)-1]=='\n') sl[strlen(sl)-1] = ' ';
  for(k=strlen(sl); k<240; k++)  sl[k] = ' ';

  if (memcmp(&sl[0], "_DEFAULT", 8)==0) {
    tlw = tld;
    if (strlen(outfile)==0)  clear_tl(tlw, "defaults.grib");
    else                     clear_tl(tlw, outfile);
    rt = 0;
  } else {
    tlw = tl;
    rt = 1;
  }
  if (memcmp(&sl[0] ,"        ",8)!=0)  memcpy(tlw->type1,&sl[0] ,8);
  if (memcmp(&sl[8] ,"    "    ,4)!=0)  memcpy(tlw->type2,&sl[8] ,4);
  if (memcmp(&sl[12],"    "    ,4)!=0)  memcpy(tlw->type3,&sl[12],4);
  if (memcmp(tlw->type1,"        ",8)==0)  return(-2);
  if (rt==1 && (memcmp(tlw->type2,"    ",4)==0 ||
                memcmp(tlw->type3,"    ",4)==0))   return(-2);
  if   (memcmp(&sl[17],"      "  ,6)!=0) {  memcpy(ss, &sl[17], 6);ss[6] = '\0';
                                            tlw->vt = atoi(ss); }
  else if (tld->vt!=-1)                     tlw->vt = tld->vt;
  if      (memcmp(&sl[24],  "    "    ,4)!=0) memcpy(tlw->memb, &sl[24],   4);
  else if (memcmp(tld->memb,"    "    ,4)!=0) memcpy(tlw->memb, tld->memb, 4);
  if      (memcmp(&sl[28],  "      "  ,6)!=0) memcpy(tlw->levl, &sl[28],   6);
  else if (memcmp(tld->levl,"      "  ,6)!=0) memcpy(tlw->levl, tld->levl, 6);
  if      (memcmp(&sl[34],  "      "  ,6)!=0) memcpy(tlw->elem, &sl[34],   6);
  else if (memcmp(tld->elem,"      "  ,6)!=0) memcpy(tlw->elem, tld->elem, 6);
  if      (sl[41]!=' ')                       tlw->bec = sl[41];
  else if (tld->bec!=' ')                     tlw->bec = tld->bec;
  if      (memcmp(&sl[42],"   "     ,3)!=0) { memcpy(ss, &sl[42], 3);ss[3]='\0';
                                              tlw->be = atoi(ss); }
  else if (tld->be!=255)                      tlw->be = tld->be;
  if      (memcmp(&sl[46],"    "    ,4)!=0) { memcpy(ss, &sl[46], 4);ss[4]='\0';
                                              tlw->xs = atoi(ss); }
  else if (tld->xs!=-999)                     tlw->xs = tld->xs;
  if      (memcmp(&sl[50],"    "    ,4)!=0) { memcpy(ss, &sl[50], 4);ss[4]='\0';
                                              tlw->xe = atoi(ss); }
  else if (tld->xe!=-999)                     tlw->xe = tld->xe;
  if      (memcmp(&sl[54],"  "      ,2)!=0) { memcpy(ss, &sl[54], 2);ss[2]='\0';
                                              tlw->xd = atoi(ss); }
  else if (tld->xd!=-999)                     tlw->xd = tld->xd;
  if      (memcmp(&sl[57],"    "    ,4)!=0) { memcpy(ss, &sl[57], 4);ss[4]='\0';
                                              tlw->ys = atoi(ss); }
  else if (tld->ys!=-999)                     tlw->ys = tld->ys;
  if      (memcmp(&sl[61],"    "    ,4)!=0) { memcpy(ss, &sl[61], 4);ss[4]='\0';
                                              tlw->ye = atoi(ss); }
  else if (tld->ye!=-999)                     tlw->ye = tld->ye;
  if      (memcmp(&sl[65],"  "      ,2)!=0) { memcpy(ss, &sl[65], 2);ss[2]='\0';
                                              tlw->yd = atoi(ss); }
  else if (tld->yd!=-999)                     tlw->yd = tld->yd;
  if      (memcmp(&sl[68],"           ",11)!=0) strcpy(tlw->fname, &sl[68]);
  else if (strlen(tld->fname)!=0)               strcpy(tlw->fname, tld->fname);
  for(i=0; i<240; i++) if (isgraph(tlw->fname[i])==0||tlw->fname[i]==' ') break;
  tlw->fname[i]='\0';
  if   (memcmp(&sl[81],"      "  ,6)!=0) {  memcpy(ss, &sl[81], 6);ss[6] = '\0';
                                            tlw->vt2= atoi(ss); }
  else if (tld->vt2!=-1)                     tlw->vt2= tld->vt2;
  if      (memcmp(&sl[88],  "      "  ,6)!=0)  memcpy(tlw->levl2, &sl[88],   6);
  else if (memcmp(tld->levl2,"      "  ,6)!=0) memcpy(tlw->levl2, tld->levl2,6);

  if (pflag!=0) {
    fprintf((pflag==1) ? stdout : stderr,
            "%s%s%s<%s%s%s%4d><%c%+2.2d>", tlw->type1,tlw->type2,tlw->type3,
                       tlw->memb,tlw->levl,tlw->elem,tlw->vt,tlw->bec,tlw->be);
    if (tlw->xs!=-999 || tlw->ys!=-999 || tlw->xe!=-999 || tlw->ye!=-999 ||
        tlw->xd!=-999 || tlw->yd!=-999)
      fprintf((pflag==1) ? stdout : stderr, "<%3d,%3d/%3d,%3d/%-d,%-d>",
              tlw->xs,tlw->ys,tlw->xe,tlw->ye,tlw->xd,tlw->yd);
    else
      fprintf((pflag==1) ? stdout : stderr,"<    all grid   >");
    if (strlen(tlw->fname)==0)
      fprintf((pflag==1) ? stdout : stderr, "[no output file]\n");
    else
      fprintf((pflag==1) ? stdout : stderr, "[%s]\n", tlw->fname);
  }
return(rt);
}
