#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <ctype.h>
#include <nwpl_string.h>
#include <nusdas.h>
#include "nusdim.h"
#include "textout.h"

static char rcsid[] = "$Id: listtype.c,v 1.15 2002/03/27 10:36:50 suuchi43 Exp $";

extern int nus_error;

	int
nusls_type(const char *pattern, const int longe) {
	char type1[9], type2[5], type3[5];
	char	*defname;
	nus_error = 0;
	nusdas_list_type(0, 0, 0, 0);
	while (nusdas_list_type(type1, type2, type3, &defname) == 0) {
		char	type[32];
		sprintf(type, "%.8s.%.4s.%.4s", type1, type2, type3);
		if (pattern != NULL) {
			if (!fmatch(pattern, type)) 
				goto nextline;
		}
		tprintf(0, "%s", type);
		if (longe)
			tprintf(0, " %s", defname);
		tprintf(0, "\n");
nextline:
		if (defname) free(defname);
	}
	return nus_error;
}
