/* nusdim.h */
/* $Id: nusdim.h,v 1.9 2003/03/07 02:30:37 tabito Exp $ */

#ifndef _NUSDIM_H
#define _NUSDIM_H

/*
 * type definitions
 */

struct grids_t {
	int	xysize[2];
    unsigned char *ucbuf;
	int	*ibuf;
	float	*fbuf;
	double	*dbuf;
};

/*
 * function prototypes
 */

/* getgrids.h */
int nusdims_get_grids(struct nus_dims_t *dp, struct grids_t *gp);
int nusdims_get_grids_uint8(struct nus_dims_t *dp, struct grids_t *gp);
int nusdims_get_grids_int32(struct nus_dims_t *dp, struct grids_t *gp);
int nusdims_get_grids_double64(struct nus_dims_t *dp, struct grids_t *gp);



/* toyoda-hacked NuSDaS */
extern int	test_dir(const char *dirname);

/* setenv.c */
extern void	set_dbdir();
extern int nusdas_addroot(const char *root);

/* panpath.c */
extern char *nusdims_to_path(const struct nus_dims_t *dp);
extern int path_to_nusdims(const char *path, struct nus_dims_t *dp);

#endif /* _NUSDIM_H */
