#include <stdio.h>
#include <stdlib.h>
#include <nwpl_string.h>
#include <nusdas.h>
#include "nusdim.h"
#include "config.h"

static char rcsid[] = "$Id: setenv.c,v 1.5 2002/03/27 10:13:39 suuchi43 Exp $";

	int
nusdas_addroot(const char *root)
{
	static int	rdno = 91;
	char	rootname[10];
	rdno--;
	if (rdno <= 0)
		return -1;
	sprintf(rootname, "NUSDAS%02d");
	putenv(strdup3(rootname, "=", root));
}

	void
set_dbdir()
{
#ifdef DBDIR
	char	*env;
	if (getenv("NUSDAS91") != NULL) return;
	env = strdup3("NUSDAS91", "=", DBDIR);
	putenv(env);
	/* don't free env! */
#endif
}
