/* errprintf.c */

#include <stdio.h>
#include <stdarg.h>
#include "nusdas_sys.h"

	void
errsys(const char *cause)
{
	perror(cause);
}

	int
errflush(void)
{
	return fflush(stderr);
}

	int
errprintf(const char *format, ...)
{
	va_list ap;
	int	i;
	va_start(ap, format);
	i = vfprintf(stderr, format, ap);
	va_end(ap);
}
