/* endian.h - byte order wrapper
 * Copyright (C) by Japan Meteorological Agency, 2001.  All rights reserved.
 * 2001-07-02 TOYODA Eizi
 */

void swab2(char *ptr, size_t nmemb);
void swab4(char *ptr, size_t nmemb);
void swab8(char *ptr, size_t nmemb);
void swab16(char *ptr, size_t nmemb);
size_t fread_native(void *ptr, size_t size, size_t nmemb, FILE * stream);
size_t fread_fmt(void *ptr, char *fmt, FILE *stream);
long btol(const unsigned char *bytes);
/* 2003.2.24 tabito added */
void endian_swab2(char *ptr, size_t nmemb);
void endian_swab4(char *ptr, size_t nmemb);
void endian_swab8(char *ptr, size_t nmemb);
void endian_swab16(char *ptr, size_t nmemb);
