#ifndef N_DEF_ESFSUB_SOURCE
N_SI4 n_set_spsubc(N_ST_SUBC *, unsigned char **);
N_SI4 n_set_spinfo(N_ST_INFO *, unsigned char **);
N_SI4 n_set_spcntl(N_ST_CNTL *, unsigned char **);
void n_get_spcntl(N_ST_CNTL *, unsigned char *);
#endif

#ifndef N_DEF_DEC2PAC_SOURCE
void n_decode_2pac_r4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_2pac_r8(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_2pac_i4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_2pac_nc(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_4pac_r8(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_1pac_i4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_1pac_i2(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_1pac_r4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
#endif

#ifndef N_DEF_DECNCMP_SOURCE
void n_decode_i4_i4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_i2_i4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_i2_i2(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_i2_r4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *, N_SI4);
void n_decode_i1_i4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_i1_i2(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_i1_i1(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_r4_r4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_r4_r8(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
void n_decode_r8_r8(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
#endif

#ifndef N_DEF_ENC2PAC_SOURCE
void n_maxmin_i2(N_SI2 *, N_SI4, N_UI1 *, N_UI1 *, N_SI2 *, N_SI2 *);
void n_maxmin_i4(N_SI4 *, N_SI4, N_UI1 *, N_UI1 *, N_SI4 *, N_SI4 *);
void n_maxmin_r8(double *, N_SI4, N_UI1 *, N_UI1 *, double *, double *);
void n_maxmin_r4(float *, N_SI4, N_UI1 *, N_UI1 *, float *, float *);
N_SI4 n_encode_2pac_r4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_2pac_r8(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_2pac_i4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_2pac_nc(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_4pac_r8(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_1pac_i2(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_1pac_i4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_1pac_r4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_2upac_r4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
#endif

#ifndef N_DEF_ENCNCMP_SOURCE
N_SI4 n_encode_i4_i4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_i2_i4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_i2_r4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *, N_SI4);
N_SI4 n_encode_i1_i1(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_i1_i2(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_i1_i4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_r4_r4(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_r4_r8(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
N_SI4 n_encode_r8_r8(N_UI1 *, N_UI1 *, N_SI4, N_UI1 *, N_UI1 *);
#endif

#ifndef N_DEF_FILESYS_SOURCE
void n_clear_cntl_mem(N_ST_CNTL *);
void n_clear_def_mem(N_ST_DEF *);
N_SI4 n_ep(const N_SI4);
N_SI4 n_set_latlon(char *, char *, float *, float *);
char	*n_spscanf(char *, N_UI4 *, const char *);
void n_char_upper(char *);
void n_make_subpath(char *buffer, size_t size, const char *dir,
                    const char *file);
void n_space_string(char *, char *);
N_SI4 n_char_check(char);
N_SI4 n_getline(FILE *, char *);
N_SI4 n_default_type(char *, char *);
N_SI4 n_def_read_key(FILE *, const char *, char *);
FILE *n_open_def_main(const char *, const char *, const char *, const char *);
FILE *n_open_def(N_SI4, char *, N_SI4 *, const char *, const char *,
const char *);
void n_replace_string(char *, const char *, const char *,
const char *, N_SI4, char *, N_SI4);
N_SI4 n_keyword_set(char *);
void n_init_def(N_ST_DEF *);
N_SI4 n_setpath(char, char *, N_ST_DEF *, char *, char *,
char *, N_SI4 *, char *, N_SI4 *, char *, char *);
#endif

#ifndef N_DEF_READDEF_SOURCE
N_SI4 n_read_def(FILE *, N_ST_DEF *);
#endif

#ifndef N_DEF_GETDATA_SOURCE
N_SI4 n_get_data(FILE *, long, N_ST_CNTL *, const char *, N_SI4 *,
N_SI4 *, const char *, const char *, const char *,
void *, const char *, const N_SI4 *);
#endif

#ifndef N_DEF_GETESF_SOURCE
N_SI4 n_get_esf(unsigned char *, N_ST_CNTL *, const char *, N_SI4 *,
N_SI4 *, const char *, const char *, const char *,
void *, const char *, const N_SI4 *);
#endif

#ifndef N_DEF_NUSSUB_SOURCE
N_SI4 n_set_esfirec(N_SI4 **, N_ST_DEF *);
N_SI4 n_set_bufsize(N_SI4, N_SI4, N_SI4 *);
N_SI4 n_check_register(N_ST_CNTL *, N_SI4, void *, void *);
N_SI4 n_rcal_bt_vt(N_SI4 *, N_SI4, N_SI4);
void n_check_fileclose(N_SI4, N_SI4);
N_SI4 n_check_fileopen(const char *, const char *, N_SI4 *);
N_SI4 n_check_defopen(const char *, const char *, N_SI4 *);
N_SI4 n_search_record(FILE *, const char *, N_SI4, N_ST_RI *);
long	n_set_next_offset(FILE *, N_ST_END *, N_SI4);
N_SI4 n_get_rlen(FILE *, long);
N_SI4 n_write_end(FILE *, N_ST_NUSD *, N_ST_END *, N_SI4);
N_SI4 n_write_nusd(FILE *, N_ST_NUSD *);
N_SI4 n_read_nusd(FILE *, N_ST_NUSD *);
N_SI4 n_write_indx(FILE *, N_ST_INDX *, N_SI4);
N_SI4 n_read_indx(FILE *, N_ST_INDX *, N_SI4);
N_SI4 n_read_cntl(FILE *, N_ST_CNTL *);
N_SI4 n_indx_p(N_ST_CNTL *, const char *, char *, N_SI4 *,
N_SI4 *, char *, char *, char *, N_SI4);
N_SI4 n_mark_end(N_SI4);
N_SI4 n_write_data(N_SI4 *, char *, N_SI4 *, N_SI4 *, char *,
char *, char *, void *, const char *,
const N_SI4 *, N_SI4, N_SI4 *, unsigned char *);
N_SI4 n_read_subc(FILE *, const char *, N_SI4, N_UI1 *, N_SI4);
N_SI4 n_write_subc(FILE *, const char *, N_SI4, N_UI1 *, N_SI4);
N_SI4 n_subc_eta_sigm(const char *, const char *, const char *, N_SI4 *,
                        const char *, N_SI4 *, N_SI4 *, char *, N_SI4 *,
                        float *, float *, float *, char *);
N_SI4 n_set_fpn(const char *, const char *, const char *, N_SI4 *,
const char *, N_SI4 *, N_SI4 *, char, N_SI4 *, N_SI4 *);
N_SI4 n_set_defn(char *, char *, char *);
void n_copy_type(const char *, const char *, const char *, const char *,
                   char *, char *, char *, char *);
void n_copy_char(const char *, const char *, const char *,
char *, char *, char *);
#endif

#ifndef N_DEF_PUTDATA_SOURCE
N_SI4 n_mbyte_set(N_ST_DATA *, N_UI1 *, N_UI1 *, N_SI4 *);
N_SI4 n_miss_mask_set(N_ST_DATA *, N_UI1 **, N_UI1 **);
N_SI4 n_alloc_dp(N_UI1 **, N_SI4);
N_SI4 n_put_data(FILE *, N_SI4 *, long, long, N_ST_CNTL *, const char *,
 		   N_SI4 *, N_SI4 *, const char *, const char *, const char *,
void *, const char *, const N_SI4 *, N_UI4, N_UI4, N_SI4,
N_SI4 *);
#endif

#ifndef N_DEF_PUTESF_SOURCE
N_SI4 n_put_esf(N_UI1 *, N_SI4 *, long, long, N_ST_CNTL *, const char *,
 		  N_SI4 *, N_SI4 *, const char *, const char *, const char *,
void *, const char *, const N_SI4 *, N_UI4, N_UI4, N_SI4,
N_SI4 *);
#endif

#ifndef N_DEF_RECORD_SOURCE
void n_timeprint(char *, N_SI4);
N_SI4 n_calc_addday(N_SI4, N_SI4, N_SI4, N_SI4);
N_SI4 n_calc_pent(N_SI4, N_SI4);
N_SI4 n_init_nusd(FILE *, N_ST_NUSD *, N_ST_DEF *, N_SI4, N_SI4, N_SI4,
N_SI4);
N_SI4 n_init_or_check_validtime(N_ST_DEF *, N_ST_CNTL *,
N_SI4 *, N_SI4 *, N_SI4);
N_SI4 n_init_cntl(FILE *, N_ST_CNTL *, N_ST_DEF *,
const char *, N_SI4 *, N_UI4 *, N_SI4 *);
N_SI4 n_init_indx(FILE *, N_ST_INDX *, N_ST_CNTL *, N_ST_DEF *,
N_SI4 *, N_SI4 *);
N_SI4 n_init_info(FILE *, N_ST_RI *, N_ST_DEF *, N_UI4 *, char *);
N_SI4 n_init_subc(FILE *, N_ST_SUBC *, N_ST_CNTL *, N_ST_DEF *, N_SI4);
void n_init_end(FILE *, N_ST_END *, N_SI4, N_SI4);
N_SI4 init_nusdas_file(FILE *, N_ST_DEF *, N_SI4, char *, N_SI4 *, N_UI4 *,
                         N_SI4 *, N_ST_NUSD *, N_ST_CNTL *, N_ST_INDX *,
                         N_ST_END *, N_ST_SUBC *, N_ST_INFO *);
N_SI4 n_init_subc_c(FILE *, N_SI4, N_ST_CNTL *, N_ST_DEF *, N_ST_SUBC *,
                      N_SI4);
N_SI4 n_init_subc_v(FILE *, N_SI4, N_SI4, N_ST_CNTL *,
N_ST_DEF *, N_SI4 *, N_SI4 *);
#endif

#ifndef N_DEF_RLENCMP_SOURCE
N_SI4 n_decode_rlen_8bit(N_UI1 *, N_UI1 *, N_SI4, N_SI4, N_SI4);
N_SI4 n_encode_rlen_8bit(N_UI1 *, N_UI1 *, N_SI4, N_SI4, N_SI4 *);
#endif

#ifndef N_DEF_UTLFUNC_SOURCE
N_SI4 n_round_i4_r4(const float);
N_SI2 n_round_i2_r4(const float);
N_SI4 n_ipow(const N_SI4, const N_SI4);
#endif

/* errprintf.c */
extern void errsys(const char *cause);
extern int errflush(void);
extern int errprintf(const char *format, ...);

/* endian.c */
#include "nusdas_endian.h"
#ifdef USE_ENDIAN_DEBUG
# define fread_swab(p,s,n,f) \
	(errprintf("#fread_swab(%p,%d,%d,%p) at %s:%d\n", \
	(p),(s),(n),(f),__FILE__,__LINE__), \
	fread_native((p),(s),(n),(f)))
# define fWrite(p,s,n,f) \
	(errprintf("#fwrite(%p,%d,%d,%p) at %s:%d\n", \
	(p),(s),(n),(f),__FILE__,__LINE__), \
	fwrite((p),(s),(n),(f)))
# define fwrite_swab(p,s,n,f) \
	(errprintf("#fwrite_swab(%p,%d,%d,%p) at %s:%d\n", \
	(p),(s),(n),(f),__FILE__,__LINE__), \
	fwrite_native((p),(s),(n),(f)))
# define fwrite_fmt(p,m,f) \
	(errprintf("#fwrite_fmt(%p,%s,%p) at %s:%d\n", \
	(p),(m),(f),__FILE__,__LINE__),fwrite_fmt ((p),(m),(f)))
#else
# define fread_swab(p,s,n,f)	fread_native((p),(s),(n),(f))
# define fWrite(p,s,n,f)	fwrite((p),(s),(n),(f))
# define fwrite_swab(p,s,n,f)	fwrite_native((p),(s),(n),(f))
#endif

#include "config_fortran.h"
#if defined(C_FORTRAN_LOWER)
# define N_ESF_OPEN n_esf_open
# define N_ESF_READ n_esf_read
# define N_ESF_WRITE n_esf_write
# define N_ESF_CLOSE n_esf_close
#elif defined(C_FORTRAN_LOWER_)
# define N_ESF_OPEN n_esf_open_
# define N_ESF_READ n_esf_read_
# define N_ESF_WRITE n_esf_write_
# define N_ESF_CLOSE n_esf_close_
#endif

/* filetest.c */
extern int test_dir(const char *dirname);
