/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

   l\WCu 

  eʏ̊iq_W  ʏ̈ܓxox

  ŏIXV | ŏIXV
  -----------+---------------------------------------------
  1999.06.10 | l\ۃvO y

  lF
    ΉĂn}e@́c
      xg      LAMBERT           eʁ̋
      |[XeI  POLARSTEREO       eʁ̋
      Jg      MERCATOR          eʁ̋
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "nwpl_mapproj.h"

/* --------------------------------------------------------------------------
    xgeʏ̍W(I,J)ɑΉܓxox߂
   -------------------------------------------------------------------------- */
int nwp_mproj_lm2ll(double **lat,double **lon,int im,int jm,double dels,      \
    double slate,double slatp,double slon,double xi,double xj,                 \
    double xlat,double xlon) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **lat : iq_̈ܓx
   (O) double **lon : iq_̌ox
   (I) int    im    : ẘiq_
   (I) int    jm    : x̊iq_
   (I) double dels  : iq_ԋ
   (I) double slate : ~ʂƋʂ̌̈ܓx(ԓ)
   (I) double slatp : ~ʂƋʂ̌̈ܓx(ɑ)
   (I) double slon  : eʏł̊ƂȂox 
   (I) double xi    : eʏł̎QƓ_̂wW
   (I) double xj    : eʏł̎QƓ_̂xW
   (I) double xlat  : ʏł̎QƓ_̈ܓx
   (I) double xlon  : ʏł̎QƓ_̌ox */

  double m,pi4,rad,rrad,slater,slatpr,slater2,slatpr2,slonr,xlatr,xlonr;
  double cp0,rcp0,acn,R0,x0,y0,x,y;
  int i,j;

  if(slate > 0) m =  1.0; /* ke */
  if(slate < 0) m = -1.0; /* 씼e */

  rad = pi/180.0;
  rrad = 180.0/pi;
  pi4 = 0.25*pi;
  slater  = m*slate*rad;
  slatpr  = m*slatp*rad;
  slater2 = pi4-slater*0.5;
  slatpr2 = pi4-slatpr*0.5;
  slonr   =   slon *rad;
  xlatr   = m*xlat *rad;
  xlonr   =   xlon *rad;
  cp0 = log(cos(slater)/cos(slatpr)) / log(tan(slater2)/tan(slatpr2));
  rcp0 = 1.0/cp0;
  acn = radEarthM*cos(slater)*rcp0;

  R0 = acn*pow(tan(pi4-xlatr*0.5)/tan(slater2),cp0);
  x0 = R0*sin((xlonr-slonr)*cp0);
  y0 = R0*cos((xlonr-slonr)*cp0);

  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      x = x0+  (i+1-xi)*dels; 
      y = y0+m*(j+1-xj)*dels; 
      lat[j][i] = m*(90.0-2.0*rrad \
                *atan(pow(sqrt(x*x+y*y)/acn,rcp0)*tan(slater2)));
/* nɂĂatan2(0.0,0.0)sɂȂĂ܂ */
      if(x==0.0 && y==0.0) {lon[j][i] = slon;}
      else {lon[j][i] = slon+rcp0*rrad*atan2(x,y);}
      if(lon[j][i] >   180.0) lon[j][i]-=360.0;
      if(lon[j][i] <= -180.0) lon[j][i]+=360.0;
    }
  }
  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
    |[XeIeʏ̍W(I,J)ɑΉܓxox߂ 
   -------------------------------------------------------------------------- */
int nwp_mproj_ps2ll(double **lat,double **lon,int im,int jm,double dels,      \
    double slat,double slon,double xi,double xj,double xlat,double xlon) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **lat : iq_̈ܓx
   (O) double **lon : iq_̌ox
   (I) int    im    : ẘiq_
   (I) int    jm    : x̊iq_
   (I) double dels  : iq_ԋ
   (I) double slat  : ʂƋʂ̌̈ܓx
                     (slat>0:ke,slat<0:씼e)
   (I) double slon  : eʏł̊ƂȂox
   (I) double xi    : eʏł̎QƓ_̂wW
   (I) double xj    : eʏł̎QƓ_̂xW
   (I) double xlat  : ʏł̎QƓ_̈ܓx
   (I) double xlon  : ʏł̎QƓ_̌ox */

  double m,rad,rrad,slatr,slonr,xlatr,xlonr;
  double R0,x0,y0,x,y;
  int i,j;

  if(slat > 0) m =  1.0; /* ke */
  if(slat < 0) m = -1.0; /* 씼e */

  rad = pi/180.0;
  rrad = 180.0/pi;
  slatr = m*slat*rad;
  slonr =   slon*rad;
  xlatr = m*xlat*rad;
  xlonr =   xlon*rad;
  
  R0 = radEarthM*(1.0+sin(slatr))*tan(0.5*(0.5*pi-xlatr));
  x0 = R0*sin(xlonr-slonr);
  y0 = R0*cos(xlonr-slonr);

  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      x = x0+  (i+1-xi)*dels;
      y = y0+m*(j+1-xj)*dels;
      lat[j][i] = m*(90.0-2.0*rrad*atan2(sqrt(x*x+y*y), \
                  radEarthM*(1.0+sin(slatr))));
/* nɂĂatan2(0.0,0.0)sɂȂĂ܂ */
      if(x==0.0 && y==0.0) { lon[j][i] = slon;}
      else { lon[j][i] = slon+rrad*atan2(x,y);}
      if(lon[j][i] >   180.0) lon[j][i]-=360.0;
      if(lon[j][i] <= -180.0) lon[j][i]+=360.0;
    }
  }
  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
    Jgeʏ̍W(I,J)ɑΉܓxox߂ 
   -------------------------------------------------------------------------- */
int nwp_mproj_mr2ll(double **lat,double **lon,int im,int jm,double dels,      \
    double slat,double xi,double xj,double xlat,double xlon) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **lat : iq_̈ܓx
   (O) double **lon : iq_̌ox
   (I) int    im    : ẘiq_
   (I) int    jm    : x̊iq_
   (I) double dels  : iq_ԋ
   (I) double slat  : ~ʂƋʂ̌̈ܓx
   (I) double xi    : eʏł̎QƓ_̂wW
   (I) double xj    : eʏł̎QƓ_̂xW
   (I) double xlat  : ʏł̎QƓ_̈ܓx
   (I) double xlon  : ʏł̎QƓ_̌ox */

  double rad,rrad,slatr,xlatr,ac,t1;
  int i,j;

  rad = pi/180.0;
  rrad = 180.0/pi;
  slatr = slat*rad;
  xlatr = xlat*rad;
  ac = radEarthM*cos(slatr);
  
  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      t1 = exp((xj-j-1)*dels/ac)*(1.0+sin(xlatr))/cos(xlatr);
      lat[j][i] = rrad*asin((t1*t1-1.0)/(t1*t1+1.0));
      lon[j][i] = xlon+rrad*(i+1-xi)*dels/ac;
    }
  }
  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
    ܓxoxɑΉ郉xgeʏ̍W(XI,XJ)߂
   -------------------------------------------------------------------------- */
int nwp_mproj_ll2lm(double **fi,double **fj,double **lat,double **lon,int im, \
    int jm,double dels,double slate,double slatp,double slon,double xi,        \
    double xj,double xlat,double xlon) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **fi  : eʏ̂wW
   (O) double **fj  : eʏ̂xW
   (I) double **lat : iq_̈ܓx
   (I) double **lon : iq_̌ox
   (I) int    im    : ẘiq_
   (I) int    jm    : x̊iq_
   (I) double dels  : iq_ԋ
   (I) double slate : ~ʂƋʂ̌̈ܓx(ԓ)
   (I) double slatp : ~ʂƋʂ̌̈ܓx(ɑ)
   (I) double slon  : eʏł̊ƂȂox
   (I) double xi    : eʏł̎QƓ_̂wW
   (I) double xj    : eʏł̎QƓ_̂xW
   (I) double xlat  : ʏł̎QƓ_̈ܓx
   (I) double xlon  : ʏł̎QƓ_̌ox */

  double m,pi4,rad,rrad,slater,slatpr,slater2,slatpr2,slonr,xlatr,xlonr;
  double cp0,rcp0,acn,R0,x0,y0,x,y,latr,lonr,r0;
  int i,j;

  if(slate > 0) m =  1.0; /* ke */
  if(slate < 0) m = -1.0; /* 씼e */

  rad = pi/180.0;
  rrad = 180.0/pi;
  pi4 = pi*0.25;
  slater = m*slate*rad;
  slatpr = m*slatp*rad;
  slater2 = pi4-slater*0.5;
  slatpr2 = pi4-slatpr*0.5;
  slonr = slon*rad;
  xlatr = m*xlat*rad;
  xlonr = xlon*rad;
  cp0 = log(cos(slater)/cos(slatpr)) / log(tan(slater2)/tan(slatpr2));
  rcp0 = 1.0/cp0;
  acn = radEarthM*cos(slater)*rcp0;
  
  R0 = acn*pow(tan(pi4-xlatr*0.5)/tan(slater2),cp0);
  x0 = R0*sin((xlonr-slonr)*cp0);
  y0 = R0*cos((xlonr-slonr)*cp0);
  
  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      if(fabs(lat[j][i])>90.0) {
        printf("nwp_mproj_ll2lm: illegal latitude value. (lat>90.0)\n");
        return NWPL_ERROR_NOTSENSIBLEVALUE;
      }
      latr = m*lat[j][i]*rad;
      lonr =   lon[j][i]*rad;
      if(lon[j][i] < 0.0) { lonr = (360.0-fabs(lon[j][i]))*rad; }
      r0 = acn*pow(tan(pi4-latr*0.5)/tan(slater2),cp0);
      x = r0*sin((lonr-slonr)*cp0);
      y = r0*cos((lonr-slonr)*cp0);
      fi[j][i] = (x-x0)/dels+xi;
      fj[j][i] = (y-y0)/dels+xj;
    }
  }
  return NWPL_NORMAL_END;
}
 
/* --------------------------------------------------------------------------
    ܓxoxɑΉ|[XeIeʏ̍W(I,J)߂
   -------------------------------------------------------------------------- */
int nwp_mproj_ll2ps(double **fi,double **fj,double **lat,double **lon,int im, \
    int jm,double dels,double slat,double slon,double xi,double xj,            \
    double xlat,double xlon) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **fi  : eʏ̂wW
   (O) double **fj  : eʏ̂xW
   (I) double **lat : iq_̈ܓx
   (I) double **lon : iq_̌ox
   (I) int    im    : ẘiq_
   (I) int    jm    : x̊iq_
   (I) double dels  : iq_ԋ
   (I) double slat  : ʂƋʂ̌̈ܓx
                      (slat>0:ke,slat<0:씼e)
   (I) double slon  : eʏł̊ƂȂox
   (I) double xi    : eʏł̎QƓ_̂wW
   (I) double xj    : eʏł̎QƓ_̂xW
   (I) double xlat  : ʏł̎QƓ_̈ܓx
   (I) double xlon  : ʏł̎QƓ_̌ox */

  double m,rad,rrad,slatr,slonr,xlatr,xlonr,latr,lonr;
  double R0,r0,x0,y0,x,y;
  int i,j;

  if(slat > 0) m =  1.0; /* ke */
  if(slat < 0) m = -1.0; /* 씼e */

  rad = pi/180.0;
  rrad = 180.0/pi;
  slatr = m*slat*rad;
  slonr =   slon*rad;
  xlatr = m*xlat*rad;
  xlonr =   xlon*rad;
  
  R0 = radEarthM*(1.0+sin(slatr))*tan(0.5*(0.5*pi-xlatr));
  x0 = R0*sin(xlonr-slonr);
  y0 = R0*cos(xlonr-slonr);

  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      if(fabs(lat[j][i])>90.0) {
        printf("nwp_mproj_ll2ps: illegal latitude value. (lat>90.0)\n");
        return NWPL_ERROR_NOTSENSIBLEVALUE;
      }
      latr = m*lat[j][i]*rad;
      lonr =   lon[j][i]*rad;
      if(lon[j][i] < 0.0) { lonr = (360.0-fabs(lon[j][i]))*rad; }
      r0 = radEarthM*(1.0+sin(slatr))*tan(0.5*(0.5*pi-latr));
      x = r0*sin(lonr-slonr);
      y = r0*cos(lonr-slonr);
      fi[j][i] = (x-x0)/dels+xi;
      fj[j][i] = (y-y0)/dels+xj;
    }
  }
  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
    ܓxoxɑΉ郁Jgeʏ̍W(I,J)߂
   -------------------------------------------------------------------------- */
int nwp_mproj_ll2mr(double **fi,double **fj,double **lat,double **lon,int im, \
    int jm,double dels,double slat,double xi,double xj,double xlat,            \
    double xlon) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **fi  : eʏ̂wW
   (O) double **fj  : eʏ̂xW
   (I) double **lat : iq_̈ܓx
   (I) double **lon : iq_̌ox
   (I) int    im    : ẘiq_
   (I) int    jm    : x̊iq_
   (I) double dels  : iq_ԋ
   (I) double slat  : ~ʂƋʂ̌̈ܓx
   (I) double xi    : eʏł̎QƓ_̂wW
   (I) double xj    : eʏł̎QƓ_̂xW
   (I) double xlat  : ʏł̎QƓ_̈ܓx
   (I) double xlon  : ʏł̎QƓ_̌ox */

  double rad,rrad,slatr,xlatr,xlonr,ac,x0,y0,x,y,latr,lonr;
  int i,j;

  rad = pi/180.0;
  rrad = 180.0/pi;
  slatr = slat*rad;
  xlatr = xlat*rad;
  xlonr = xlon*rad;
  ac = radEarthM*cos(slatr);
  x0 = 0.0;
  y0 = ac*log((1.0+sin(xlatr))/cos(xlatr));
 
  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      if(fabs(lat[j][i])>90.0) {
        printf("nwp_mproj_ll2mr: illegal latitude value. (lat>90.0)\n");
        return NWPL_ERROR_NOTSENSIBLEVALUE;
      }
      latr = lat[j][i]*rad;
      lonr = lon[j][i]*rad;
      if(lon[j][i] < 0.0) { lonr = (360.0-fabs(lon[j][i]))*rad; }
      x = ac*(lonr-xlonr);
      y = ac*log((1.0+sin(latr))/cos(latr));
      fi[j][i] = (x-x0)/dels+xi;
      fj[j][i] = (y0-y)/dels+xj;
    }
  }
  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
    ʁxgẽ}bvt@N^[߂
   -------------------------------------------------------------------------- */
int nwp_mf_lm(double **mf,double **lat,int im,int jm,double slate,            \
    double slatp) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **mf  : }bvt@N^[
   (I) double **lat : iq_̈ܓx
   (I) int    im    : ẘiq_
   (I) int    jm    : x̊iq_
   (I) double slate : ~ʂƋʂ̌̈ܓx(ԓ)
   (I) double slatp : ~ʂƋʂ̌̈ܓx(ɑ) */

  double rad,pi4,slater,slatpr,slater2,slatpr2,cp0,p1;
  int i,j;

  rad = pi/180.0;
  pi4 = pi*0.25;
  slater = slate*rad;
  slatpr = slatp*rad;
  slater2 = pi4-slater*0.5;
  slatpr2 = pi4-slatpr*0.5;
  cp0 = log(cos(slater)/cos(slatpr)) / log(tan(slater2)/tan(slatpr2));
  p1 = cos(slater) / pow(tan(slater2),cp0);

  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      if(fabs(lat[j][i])>90.0) { 
        printf("nwp_mf_lm: illegal latitude value. (lat>90.0)\n");
        return NWPL_ERROR_NOTSENSIBLEVALUE;
      }
      mf[j][i] = p1*pow(tan(pi4-fabs(lat[j][i])*rad*0.5),cp0)/cos(lat[j][i]*rad);
    }
  }
  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
    ʁ|[XeIẽ}bvt@N^[߂
   -------------------------------------------------------------------------- */
int nwp_mf_ps(double **mf,double **lat,int im,int jm,double slat) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* F
   (O) double **mf  : }bvt@N^[
   (I) double **lat : iq_̈ܓx
   (I) int    im    : ẘiq_
   (I) int    jm    : x̊iq_
   (I) double slat  : ʂƋʂ̌̈ܓx */

  double rad,slatr;
  int i,j;

  rad = pi/180.0;
  slatr = slat*rad;
  
  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      if(fabs(lat[j][i])>90.0) { 
        printf("nwp_mf_ps: illegal latitude value. (lat>90.0)\n");
        return NWPL_ERROR_NOTSENSIBLEVALUE;
      }
      mf[j][i] = (1.0+fabs(sin(slatr))) / (1.0+fabs(sin(lat[j][i]*rad)));
    }
  } 
  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
    ʁJgẽ}bvt@N^[߂
   -------------------------------------------------------------------------- */
int nwp_mf_mr(double **mf,double **lat,int im,int jm,double slat) {

#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* :
   (O) double **mf  : }bvt@N^[
   (I) double **lat : iq_̈ܓx
   (I) int im       : ẘiq_
   (I) int jm       : x̊iq_
   (I) double slat  : ~ʂƋʂ̌̈ܓx */

  double rad,slatr;
  int i,j;

  rad = pi/180.0;
  slatr = slat*rad;
  
  for(j=0; j<jm; j++) {
    for(i=0; i<im; i++) {
      if(fabs(lat[j][i])>90.0) { 
        printf("nwp_mf_mr: illegal latitude value. (lat>90.0)\n");
        return NWPL_ERROR_NOTSENSIBLEVALUE;
      }
      mf[j][i] = cos(slatr) / cos(lat[j][i]*rad);
    }
  } 
  return NWPL_NORMAL_END;
}

/* --------------------------------------------------------------------------
    ʏ̂Q_Ԃ̋(Q_ʂ~ɉ)߂
   -------------------------------------------------------------------------- */
double nwp_distance(double alat,double alon,double blat,double blon) {
  
#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"

/* 
   double alat : _`̈ܓx
   double alon : _`̌ox
   double blat : _äܓx
   double blon : _ǎox */

  double rad,alpha,alatr,blatr,lonr;

  rad = pi/180.0;
  alatr = alat*rad;
  blatr = blat*rad;
  lonr = (blon-alon)*rad;
  alpha = acos(sin(alatr)*sin(blatr)+cos(alatr)*cos(blatr)*cos(lonr));
  return alpha*radEarthM;
}
