/*
 * nwpl_string.h - l\WCu2Ōv 񏈗
 * $Id: nwpl_string.h,v 1.4 2002/04/05 11:48:32 suuchi43 Exp $
 */

#ifndef NWPL_STRING_H
# define NWPL_STRING_H

/* str.c */
# define streq(a, b) (strcmp((a), (b)) == 0)
extern int      streqi(const char *a, const char *b);
extern int	memeqi(const char *a, const char *b, size_t n);
extern char     *strdup3(const char *a, const char *b, const char *c);
extern int      indexc(const char *string, char c);
extern char     *string_copy(char *dest, size_t size, const char *src);
extern void     string_to_fstring(char *dest, size_t size, const char *src);
extern void     fstring_to_fstring(char *dest, const size_t dsize,
	const char *src, const size_t ssize);
extern char     *fstring_to_string(char *dest, const size_t dsize,
	const char *src, const size_t ssize);
extern int      fmatch(const char *pattern, const char *text);
extern int      replace_space(char *buf, unsigned len);

/* regmatch.c */

extern long	regmatch(const char *pattern, const char *text, long *length);
extern char	*regreplace(const char *pattern, const char *replace,
		const char *text) ;

#endif /* ifndef NWPL_STRING_H */
