#line 1 "wrapf90.ca"

# include "nusdas_sys.h"
# include "config_fortran.h"
# define CHAR char
# define INTEGER int
# define REAL float
# define DOUBLE double

#line 315 "wrapf90.ca"

void

#ifdef C_FORTRAN_UPPER
NUSDAS_SUBC_SRF2
#else
#  ifdef C_FORTRAN_LOWER_
nusdas_subc_srf2_
#  else
fnusdas_subc_srf2
#  endif
#endif

#line 319 "wrapf90.ca"
(const CHAR *utype1,
 const CHAR *utype2,
 const CHAR *utype3,
 INTEGER *basetime,
 const CHAR *udescriptor,
 INTEGER *validtime1,
 INTEGER *validtime2,
 const CHAR *ulevel1,
 const CHAR *ulevel2,
 const CHAR *uelement,
 const CHAR *gname,
 INTEGER *rinfo,
 CHAR *action,
 INTEGER *rt)
{
    *rt = nusdas_subc_srf2(utype1, utype2, utype3, basetime, udescriptor,
			   validtime1,
			   validtime2, ulevel1, ulevel2, uelement, gname,
			   rinfo, action);
}

